/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ase.h"

ase_loadMesh(FILE *in,aseobj *obj)
{
  char tmp[201];
  char *ptr;
  do {
    fgets(tmp,200,in);
    ptr=strtok(tmp," \t\r");
    if(!strcmp(ptr,"*MESH_NUMVERTEX")){
      ptr=strtok(NULL," \t\r");
      obj->numVertex=atoi(ptr);
      obj->vertex=(v_3*)malloc(obj->numVertex*sizeof(float[3]));
    } 
    else if(!strcmp(ptr,"*MESH_NUMFACES")){
      ptr=strtok(NULL," \t\r");
      obj->numFaces=atoi(ptr);
      obj->face=(i_3*)malloc(obj->numFaces*sizeof(int[3]));
    } 
    else if(!strcmp(ptr,"*MESH_VERTEX_LIST")) {
      do {
	fgets(tmp,200,in);
	ptr=strtok(tmp," \t\r");
	if(!strcmp(ptr,"*MESH_VERTEX")) {
	  int n;
	  ptr=strtok(NULL," \t\r");
	  n=atoi(ptr);
	  ptr=strtok(NULL," \t\r");
	  obj->vertex[n][0]=atof(ptr);
	  ptr=strtok(NULL," \t\r");
	  obj->vertex[n][1]=atof(ptr);
	  ptr=strtok(NULL," \t\r");
	  obj->vertex[n][2]=atof(ptr);
	} 
	else if(!strcmp(ptr,"}"))
	  break;
      }
      while(!feof(in));
    }
    else if(!strcmp(ptr,"*MESH_FACE_LIST")) {
      do {
	fgets(tmp,200,in);
	ptr=strtok(tmp," \t\r");
	if(!strcmp(ptr,"*MESH_FACE")) {
	  int n;
	  ptr=strtok(NULL," :\t\r");
	  n=atoi(ptr);
	  strtok(NULL," :\t\r");
	  ptr=strtok(NULL," :\t\r");
	  obj->face[n][0]=atoi(ptr);
	  strtok(NULL," :\t\r");
	  ptr=strtok(NULL," :\t\r");
	  obj->face[n][1]=atoi(ptr);
	  strtok(NULL," :\t\r");
	  ptr=strtok(NULL," :\t\r");
	  obj->face[n][2]=atoi(ptr);
	} 
	else if(!strcmp(ptr,"}"))
	  //break; 
	  return;
      }
      while(!feof(in));
    }
    //else if(!strcmp(ptr,"}"))
    //  break;
  }
  while(!feof(in));
}

ase_loadObj(FILE *in,aseobj *obj)
{
  char tmp[201];
  char *ptr;
  do {
    fgets(tmp,200,in);
    ptr=strtok(tmp," \t\r");
    if(!strcmp(ptr,"*MESH")) {
      ase_loadMesh(in,obj);
      break;
    } 
    //else if(!strcmp(ptr,"}"))
    //  break;
  }
  while(!feof(in));
}  

int ase_load(const char *filename,aseobj *obj)
{
  FILE *in;
  char tmp[201];
  char *ptr;
  if((in=fopen(filename,"r"))==NULL) return 0;
  do {
    fgets(tmp,200,in);
    ptr=strtok(tmp," \t\r");
    if(!strcmp(ptr,"*GEOMOBJECT")) {
      ase_loadObj(in,obj);
      break;
    }
  }
  while(!feof(in));

  fclose(in);
}
