/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* 04/08/00 */

#include <math.h>
#include <malloc.h>
#include "shadows.h"
#include "utils.h"

int RCH=0;
int dShad=0;
int stat[5];
extern void XX(shadows_t *s);

extern int shadows_triangulate(shadows_poly_t tabRet[],int nbrRetPoly,/*svec_t tabRetXY[][2],int nbrRetPt,*/int nbrRetHole,shadows_ret_t tabRetPoly[],int tabRetId[]);

//#define DECAL_SEGMASK 4
#define DECAL_SEGMASK 3
#define SEGMASK_0 0x1
#define SEGMASK_1 0x2
#define SEGMASK_2 0x4
//#define SEGMASK_NEW 0x8

#define DECAL_PTMASK 2
#define PTMASK_0 0x1
#define PTMASK_1 0x2

#define DECAL_PTMASK2 DECAL_PTMASK
//#define PTMASK2_0 0x1


#if DECAL_SEGMASK > DECAL_PTMASK
#define MAX_DECAL DECAL_SEGMASK
#else
#define MAX_DECAL DECAL_PTMASK
#endif

#define MAX_NSEG 8*sizeof(mask_t)-MAX_DECAL

#define POLY_X(i) vertex[face[i]][0]
#define POLY_Y(i) vertex[face[i]][1]
#define POLY_Z(i) vertex[face[i]][2]

#ifndef SHADOWS_RET_3D
#error SHADOWS_RET_3D doit etre active
#endif

int NODE_CUT_LIM=12;
int NODE_MERGE_LIM=8;
//#define NODE_CUT_LIM 18
//#define NODE_MERGE_LIM 12

// FIX
// retour
shadows_poly_t tabRet[20];
#ifdef SHADOWS_RET_3D
svec_t tabRetXY[100][3];
#else
svec_t tabRetXY[100][2];
#endif
shadows_ret_t tabRetPoly[200];
int tabRetId[700];
int nbrRetPt;
int nbrRetPoly;
int nbrRetHole;
int nbrRet;

typedef struct {
  shadows_ptrseg_t *ptrseg;
  shadows_seg_t *seg;
  svec_t x,y;
  // SPEED ifdef ret3d
  svec_t z;
  shadows_pt_t *pt;
} info_seg_t;

#include "shadows_constr.c"
	
/***************** ADDPOLY *****************/

shadows_seg_t listSeg;
shadows_pt_t *ppt_complet;
zone_t Zone;
int minNbrSegCheck;
shadows_node_t *minNodeCheck;
zone_t minZoneCheck;
shadows_pt_t *minPtCheck;
info_seg_t tabInfo[MAX_NSEG];

INLINE static zone_t checkpoint(shadows_t *s,shadows_node_t *node,zone_t zone,svec_t x,svec_t y);


/*
// FIX A VIRER
void verInt(shadows_node_t *node) 
{
  shadows_pt_t *ppt;
  shadows_seg_t *pseg;
  shadows_ptrseg_t *ptrseg;
  int l=0;

  if(node->nbrPtrseg<0) {
    for(l=0;l<4;l++)
      verInt(node->fils[l]);
    return;
  }
 
  for(ppt=node->pt.next;ppt!=&node->pt;ppt=ppt->next) {
    assert(ppt->mask==0);
#ifdef SHADOWS_RET_3D
    assert(ppt->mask2==0);
#endif
  }

  for(ptrseg=node->ptrseg.next;ptrseg!=NULL;ptrseg=ptrseg->next) {
    l++;
    if(ptrseg->aft) {
      if(ptrseg->aft->bef!=ptrseg) {
	printf("%p\n",ptrseg->seg);
      }
      assert(ptrseg->aft->bef==ptrseg);
    }
    if(ptrseg->bef) {
      if(ptrseg->bef->aft!=ptrseg) {
	printf("%p\n",ptrseg->seg);
      }
      assert(ptrseg->bef->aft==ptrseg);
    }
    assert(ptrseg->seg);
    assert(ptrseg->seg->mask==0);
  }
  
  assert(l==node->nbrPtrseg);
}



void verInt2(shadows_node_t *node) 
{
  shadows_pt_t *ppt;
  shadows_seg_t *pseg;
  shadows_ptrseg_t *ptrseg;
  int l=0;

  if(node->nbrPtrseg<0) {
    for(l=0;l<4;l++)
      verInt2(node->fils[l]);
    return;
  }
 
  //for(ppt=node->pt.next;ppt!=&node->pt;ppt=ppt->next) {
  //  assert(ppt->mask==0);
  //}

  for(ptrseg=node->ptrseg.next;ptrseg!=NULL;ptrseg=ptrseg->next) {
    l++;
    if(ptrseg->aft) {
      if(ptrseg->aft->bef!=ptrseg) {
	printf("%p\n",ptrseg->seg);
      }
      assert(ptrseg->aft->bef==ptrseg);
    }
    if(ptrseg->bef) {
      if(ptrseg->bef->aft!=ptrseg) {
	printf("%p\n",ptrseg->seg);
      }
      assert(ptrseg->bef->aft==ptrseg);
    }
    //if(ptrseg->seg)
    //  assert(ptrseg->seg->mask==0);
  }
  
  assert(l==node->nbrPtrseg);
}
*/

#define FREESEG(s,seg) { \
  seg->next=s->freeSeg; \
  s->freeSeg=seg; } \

#define FREENODE(s,node) { \
  node->next=s->freeNode; \
  s->freeNode=node; } \

#define FREEPTRSEG(s,ptrseg) { \
  ptrseg->next=s->freePtrseg; \
  s->freePtrseg=ptrseg; } \

#define FREEPT(s,pt) { \
  pt->next=s->freePt; \
  s->freePt=pt; } \

#define NEWSEG(s,seg) { \
  if((seg=s->freeSeg)==NULL) { \
    addNewSeg(s); \
    seg=s->freeSeg; \
  } \
  s->freeSeg=seg->next; \
} \

#define NEWPTRSEG(s,ptrseg) { \
  if((ptrseg=s->freePtrseg)==NULL) { \
    addNewPtrseg(s); \
    ptrseg=s->freePtrseg; \
  } \
  s->freePtrseg=ptrseg->next; \
} \

#define NEWPT(s,pt) { \
  if((pt=s->freePt)==NULL) { \
    addNewPt(s); \
    pt=s->freePt; \
  } \
  s->freePt=pt->next; \
} \

#define NEWNODE(s,node) { \
  if((node=s->freeNode)==NULL) { \
    addNewNode(s); \
    node=s->freeNode; \
  } \
  s->freeNode=node->next; \
} \

static void addNewSeg(shadows_t *s) {
  assert(0);
}

static void addNewPtrseg(shadows_t *s) {
  assert(0);
}

static void addNewNode(shadows_t *s) {
  assert(0);
}

static void addNewPt(shadows_t *s) {
  assert(0);
}

//SPEED
//INLINE inline 
INLINE static svec_t COTESEGXY(shadows_seg_t *s,svec_t x,svec_t y)
{
  return ((s->xo1-s->xo0)*(y-s->yo0)-(s->yo1-s->yo0)*(x-s->xo0));
}


#define COTESEGXY_(s,x,y) (((s)->xo1-(s)->xo0)*((y)-(s)->yo0)-((s)->yo1-(s)->yo0)*((x)-(s)->xo0))
//#define COTESEGXY_(s,x,y) COTESEGXY(s,x,y)


//SPEED
//INLINE inline 
INLINE static svec_t COTESEGXY2(shadows_seg_t *s,svec_t x,svec_t y)
{
  if(s->sens==0)
    return COTESEGXY_(s,x,y);
  else
    return -COTESEGXY_(s,x,y);
}

//SPEED
//INLINE 
inline static svec_t COTESEGXY2_(shadows_seg_t *s,svec_t x,svec_t y)
{
  if(s->sens==0)
    return COTESEGXY_(s,x,y);
  else
    return -COTESEGXY_(s,x,y);
}


// FIX;
int cZi,cZProj;
// a virer
int cZC=0;

//typedef svec_t svec3_t[3];
//svec3_t *cZTab;
svec_t (*cZTab)[3];

INLINE void initCalcZ(svec_t tabRetXY[][3],int proj_parallele)
{
  if(dShad) printf("%d calcZ\n",cZC);
  cZC=0;
  cZi=0;
  cZProj=proj_parallele;
  cZTab=tabRetXY;
}

INLINE svec_t calcZ(shadows_pt_t *ppt)
{
  static svec_t a,b,c,d;
  
  cZC++;
  //return 0.;
  
  if(!cZi) {
    cZi=1;
    b=(cZTab[1][1]-cZTab[0][1])*(cZTab[2][2]-cZTab[0][2])-(cZTab[1][2]-cZTab[0][2])*(cZTab[2][1]-cZTab[0][1]);
    c=(cZTab[1][2]-cZTab[0][2])*(cZTab[2][0]-cZTab[0][0])-(cZTab[1][0]-cZTab[0][0])*(cZTab[2][2]-cZTab[0][2]);
    d=(cZTab[1][0]-cZTab[0][0])*(cZTab[2][1]-cZTab[0][1])-(cZTab[1][1]-cZTab[0][1])*(cZTab[2][0]-cZTab[0][0]);
    a=cZTab[0][0]*b+cZTab[0][1]*c+cZTab[0][2]*d;
  }
    
  if(cZProj) {
    return ((a+ppt->x*b+ppt->y*c)/d);
  } else {
    return (a/(ppt->x*b+ppt->y*c+d));
  }
}

#include "shadows_node.c"

/************/

INLINE static void REMOVEPTSEG(shadows_t *s,shadows_pt_t *ppt,
			      shadows_seg_t *nseg,char ncote) 
{
  char c1,c2;
  shadows_seg_t *s1,*s2;

  //assert(ppt==nseg->p[ncote].pt);
  
  if((--(ppt->nbr))==0) {
  /*if((--(nseg->p[ncote].pt->nbr))==0) 
    FREEPT(s,nseg->p[ncote].pt);*/
    ppt->next->prev=ppt->prev;
    ppt->prev->next=ppt->next;
    FREEPT(s,ppt);
  }
  else {
    s1=nseg->p[ncote].next;
    s2=nseg->p[ncote].prev;
    c1=nseg->p[ncote].nextCote;
    c2=nseg->p[ncote].prevCote;
    /*if(nseg->p[ncote].pt->seg==nseg) {
      nseg->p[ncote].pt->seg=s1;
      nseg->p[ncote].pt->cote=c1;
      }*/
    if(ppt->seg==nseg) {
      ppt->seg=s1;
      ppt->cote=c1;
    }
    s1->p[c1].prev=s2;
    s1->p[c1].prevCote=c2;
    s2->p[c2].next=s1;
    s2->p[c2].nextCote=c1;
  }
}

INLINE static void ADDPTSEG(shadows_t *s,shadows_pt_t *ppt,
			      shadows_seg_t *nseg,char ncote) 
{
  shadows_seg_t *psegt,*psegt2;
  char cote,ctmp;
  int k;
  /*for(k=0,psegt=ppt->seg,cote=ppt->cote;k<ppt->nbr;k++) {
    ctmp=psegt->p[cote].nextCote;
    psegt=psegt->p[cote].next;
    cote=ctmp;
    }*/
  if(ppt->nbr==0){
    ppt->seg=nseg;
    ppt->cote=ncote;
    ppt->nbr=1;
    nseg->p[ncote].next=nseg->p[ncote].prev=nseg;
    nseg->p[ncote].nextCote=nseg->p[ncote].prevCote=ncote;
    nseg->p[ncote].pt=ppt;
  } else
    for(k=0,psegt=ppt->seg,cote=ppt->cote;k<=ppt->nbr;k++) {
      if(k!=ppt->nbr && psegt->p[cote].tet==nseg->p[ncote].tet) {
	if(psegt->p[1-cote].pt==nseg->p[1-ncote].pt 
	   && psegt->p[1-cote].pt!=NULL) {
	  // effacage nseg
	  //if(dShad) printf("segs == -> effacage\n");
	  if(cote==ncote)
	    psegt->mask|=SEGMASK_1 | SEGMASK_0;
	  else
	    psegt->mask|=SEGMASK_2 | SEGMASK_0;
	  //psegt->p[cote].nzone=nseg->p[ncote].nzone;
	  //psegt->p[1-cote].nzone=nseg->p[1-ncote].nzone;
	  REMOVEPTSEG(s,nseg->p[1-ncote].pt,nseg,1-ncote);
	  nseg->mask=0; //?
	  break;
	}
      }
      if(k==ppt->nbr || psegt->p[cote].tet > nseg->p[ncote].tet) {
	nseg->p[ncote].next=psegt;
	nseg->p[ncote].nextCote=cote;
	psegt2=nseg->p[ncote].prev=psegt->p[cote].prev;
	ctmp=nseg->p[ncote].prevCote=psegt->p[cote].prevCote;
	psegt->p[cote].prev=nseg;
	psegt->p[cote].prevCote=ncote;
	psegt2->p[ctmp].next=nseg;
	psegt2->p[ctmp].nextCote=ncote;
	ppt->nbr++;
	nseg->p[ncote].pt=ppt;
	if(k==0) {
	  ppt->seg=nseg;
	  ppt->cote=ncote;
	}
	break;
      }
      ctmp=psegt->p[cote].nextCote;
      psegt=psegt->p[cote].next;
      cote=ctmp;
    }
}

INLINE static void CUTSEG(shadows_t *s,shadows_pt_t *ppt,
			     shadows_seg_t *nseg,shadows_seg_t *nsegt) 
{
  nsegt->xo0=nseg->xo0;
  nsegt->yo0=nseg->yo0;
  nsegt->xo1=nseg->xo1;
  nsegt->yo1=nseg->yo1;
  // SPEED (inutile pour pseg)
  nsegt->id=nseg->id;
  //nsegt->mask|= nseg->mask & SEGMASK_NEW;
  nsegt->next=nseg->next;
  nseg->next=nsegt;
  nsegt->p[1]=nseg->p[1];
  nsegt->p[1].next->p[nsegt->p[1].nextCote].prev=nsegt;
  nsegt->p[1].prev->p[nsegt->p[1].prevCote].next=nsegt;
  // SPEED (inutile pour nseg)
  nsegt->p[0].zone=nseg->p[0].zone;
  nsegt->p[1].zone=nseg->p[1].zone;
  nsegt->sens=nseg->sens;
  if(nsegt->p[1].pt->seg==nseg) nsegt->p[1].pt->seg=nsegt;
  nsegt->p[0].x=nseg->p[1].x=ppt->x;
  nsegt->p[0].y=nseg->p[1].y=ppt->y;
  nsegt->p[0].tet=nseg->p[0].tet;
  ADDPTSEG(s,ppt,nseg,1);
  ADDPTSEG(s,ppt,nsegt,0);
}

//#define INTERSEC(s1,s2)
//INLINE inline 
INLINE static int INTERSEC(shadows_seg_t *s1,shadows_seg_t *s2)
{
  // FIX

  svec_t a,b,c;//,d;
  if(((a=COTESEGXY_(s1,s2->p[0].x,s2->p[0].y))*
      (b=COTESEGXY_(s1,s2->p[1].x,s2->p[1].y)) <= 0.) &&
     ((c=COTESEGXY_(s2,s1->p[0].x,s1->p[0].y))*
      (/*d=*/COTESEGXY_(s2,s1->p[1].x,s1->p[1].y)) <= 0.)) {
    if(a==0. && b==0. && c==0.) // && d==0.)
      return 0;
    return 1;
  }
  else
    return 0;

}

//TEST
INLINE static int INTERSEC_(shadows_seg_t *s1,shadows_seg_t *s2)
{
  // FIX
  svec_t a,b,c;
  //double a,b,c;

  if(((a=COTESEGXY_(s1,s2->p[0].x,s2->p[0].y))*
      (b=COTESEGXY_(s1,s2->p[1].x,s2->p[1].y)) <= 0.) &&
     ((c=COTESEGXY_(s2,s1->p[0].x,s1->p[0].y))*
      (/*d=*/COTESEGXY_(s2,s1->p[1].x,s1->p[1].y)) <= 0.)) {
    if(a==0. && b==0. && c==0.) // && d==0.)
      return 0;
    return 1;
  }
  else
    return 0;
}

INLINE static void CALCINTERSEC(shadows_seg_t *s0,shadows_seg_t *s1,
				svec_t *x,svec_t *y)
{
  svec_t dx0=(s0->xo1-s0->xo0);
  svec_t dx1=(s1->xo1-s1->xo0);
  svec_t dy0=(s0->yo1-s0->yo0);
  svec_t dy1=(s1->yo1-s1->yo0);
  svec_t det=dx0*dy1-dx1*dy0;
  svec_t a0=s0->xo0*s0->yo1 - s0->xo1*s0->yo0;
  svec_t a1=s1->xo0*s1->yo1 - s1->xo1*s1->yo0;
  //assert(det!=0.);
  *x=(-a0*dx1+a1*dx0)/det;
  *y=(+dy0*a1-dy1*a0)/det;
} 

INLINE static void PARCOURS_(shadows_seg_t *pseg,char cote_,zone_t z,zone_t z2)
{
  zone_t z_=ADDZONE(z,z2);
  char cote=cote_,ctmp;
  shadows_seg_t *psegt=pseg;
  shadows_pt_t *ppt;
  svec_t fc;
  do {
    psegt->p[cote].zone=z_;
    if(psegt->id!=MAX_NSEG) {
      //if(psegt->mask & SEGMASK_NEW) {
      psegt->p[1-cote].zone=z;
    }
    ppt=psegt->p[1-cote].pt;
    psegt->mask|=SEGMASK_1<<cote;
    ctmp=1-psegt->p[cote].nextCote;
    psegt=psegt->p[cote].next;
    cote=ctmp;

  } while(psegt!=pseg);
} 

INLINE static void PARCOURS(shadows_seg_t *pseg,char cote_,zone_t z,zone_t z2)
{
  zone_t z_=ADDZONE(z,z2);
  char cote=cote_,ctmp;
  shadows_seg_t *psegt=pseg;
  shadows_pt_t *ppt;
  shadows_seg_2_t *seg_2,*oseg_2;
  svec_t fc,aera=0.;
  int i=0;

  if(dShad) printf("Parcours\n");

  if(ZONENORET(z)) PARCOURS_(pseg,cote_,z,z2);
  seg_2=&pseg->p[cote];
  tabRet[nbrRetPoly].seg_2=seg_2;
  tabRet[nbrRetPoly].zone=z;
  do {
    oseg_2=seg_2;
    psegt->p[cote].zone=z_;
    if(psegt->id!=MAX_NSEG) {
      //if(psegt->mask & SEGMASK_NEW) {
      if(dShad) printf("new\n");
      psegt->p[1-cote].zone=z;
    }
    else if(dShad) printf("old\n");
    ppt=psegt->p[1-cote].pt;
    psegt->mask|=SEGMASK_1<<cote;
    ctmp=1-psegt->p[cote].nextCote;
    psegt=psegt->p[cote].next;
    cote=ctmp;

    fc=COTESEGXY2(psegt,ppt->x,ppt->y);
    if(cote==0) fc=-fc;
    if(fc<0.) {oseg_2->concave=1;i++;}
    else oseg_2->concave=0;
    seg_2=&psegt->p[cote];
    seg_2->prevP=oseg_2;
    oseg_2->nextP=seg_2;
    aera+=seg_2->x*oseg_2->y-seg_2->y*oseg_2->x;
  } while(psegt!=pseg);
  oseg_2->nextP=&pseg->p[cote_];
  pseg->p[cote].prevP=oseg_2;

  if(aera<0.) {
    tabRet[nbrRetPoly].hole=1;
    nbrRetHole++;
  }
  else tabRet[nbrRetPoly].hole=0;

  tabRet[nbrRetPoly].concave=i;
  nbrRetPoly++;

  assert(nbrRetPoly<(sizeof(tabRet)/sizeof(shadows_poly_t)));
} 

//INLINE 
INLINE static void P1(shadows_t *s,int nbrSeg)
{  
  int i;
  shadows_seg_t *pseg,*nseg;
  shadows_pt_t *ppt;
  
  //if(dShad) printf("--1--\n");
  /* 1e parcours : test segs == */
  {
    pseg=listSeg.next;
    while(pseg!=NULL) {
      
      if(pseg->mask!=SEGMASK_0)
	for(i=0;i<nbrSeg;i++)  
	  if(pseg->mask & (1<<(i+DECAL_SEGMASK))
	     && pseg->xo0==tabInfo[i].seg->xo0 
	     && pseg->xo1==tabInfo[i].seg->xo1
	     && pseg->yo0==tabInfo[i].seg->yo0
	     && pseg->yo1==tabInfo[i].seg->yo1) { // segs == 
	    //if(dShad) printf("segs ==\n");
	    
	    pseg->p[0].pt->mask|=1<<(i+DECAL_PTMASK);
	    pseg->p[1].pt->mask|=1<<(i+DECAL_PTMASK);

	    // SPEED 
	    //pseg->p[0].pt->mask2=pseg->p[1].pt->mask2=0;

#ifdef SHADOWS_RET_3D
	    if(pseg->zo0==tabInfo[i].seg->zo0
	       && pseg->zo1==tabInfo[i].seg->zo1) { // segs == dans l'espace
	      pseg->p[0].pt->mask2|=1<<(i+DECAL_PTMASK2);
	      pseg->p[1].pt->mask2|=1<<(i+DECAL_PTMASK2);
	    }
#endif	
	    break; 
	  }
      pseg=pseg->next;
    }
  }
} 

//INLINE 
INLINE static void P2(shadows_t *s,int nbrSeg)
{  
  int i,j,k;
  shadows_seg_t *pseg,*nseg;
  shadows_pt_t *ppt;
  
  //if(dShad) printf("--2--\n");

  /* 2eme parcours : test pt sur nseg */
  {
    shadows_seg_t *nsegt;
    char cote,ctmp;
    svec_t z;

    pseg=listSeg.next;
    while(pseg!=NULL) {
      for(j=0;j<2;j++)
	if(!((ppt=pseg->p[j].pt)->mask & PTMASK_0)) {
	  if(ppt->mask & ~(PTMASK_0 | PTMASK_1)) {
	    // SPEED (faire passer i en dehors de la boucle nseg)
	    for(i=0,nseg=tabInfo[0].seg;i<nbrSeg;(nseg=nseg->next) || (i++,((i<nbrSeg) && (nseg=tabInfo[i].seg)))) {
	      if(nseg->mask) {
		if( (ppt->mask & 1<<(i+DECAL_PTMASK)) && 
		    ((ppt->x-nseg->p[0].x)*(ppt->x-nseg->p[1].x) <=0.) &&
		    ((ppt->y-nseg->p[0].y)*(ppt->y-nseg->p[1].y) <=0.)) {
		  // pt sur nseg 
		  if(dShad) printf("pt sur seg (1)\n"); 
		  // SPEED  a virer ?
		  ppt->mask|=PTMASK_1;
		  // enlever de mask de tous les segs autour de pt 1<<(id+1) 
		  for(k=0,nsegt=ppt->seg,cote=ppt->cote;k<ppt->nbr;k++) {
		    nsegt->mask&=~(1<<(i+DECAL_SEGMASK));
		    ctmp=nsegt->p[cote].nextCote;
		    nsegt=nsegt->p[cote].next;
		    cote=ctmp;
		  }
		  // cree nouv seg et le chaine 
		  NEWSEG(s,nsegt);
		  nsegt->mask=SEGMASK_0;
		  CUTSEG(s,ppt,nseg,nsegt);
		  ppt_complet=ppt;

#ifdef SHADOWS_RET_3D
		  // SPEED (enlever ?)
		  //if((ppt->mask2 & PTMASK2_0) /*== 0*/) {
		  if(ppt->idRet==-1) {
		    if(ppt->mask2 & (1<<(i+DECAL_PTMASK2))) { // pt sur seg dans l'espace
		      z=ppt->z;
		      // SPEED SPEED 
		      //z=calcZ(ppt);
		      //ppt->z=z;
		    } else {
		      z=calcZ(ppt);
		      ppt->z=z;
		    }
		    if(dShad) printf("point sur seg\n"); 
		    ppt->idRet=nbrRetPt;
		    if(s->proj) {
		      tabRetXY[nbrRetPt][0]=ppt->x;
		      tabRetXY[nbrRetPt][1]=ppt->y;
		    } else {
		      tabRetXY[nbrRetPt][0]=ppt->x*z;
		      tabRetXY[nbrRetPt][1]=ppt->y*z;
		    }
		    tabRetXY[nbrRetPt][2]=z;
		    
		    nbrRetPt++;
		  }
#endif
		  break;
		}
	      }
	    }
	    ppt->mask|=PTMASK_0;
	  }
#ifdef SHADOWS_RET_3D
	  else {
	    if((ppt->mask & PTMASK_1) && ppt->idRet==-1) { //((ppt->mask2 & PTMASK2_0)/*==0*/)) {
	      
	      if(dShad) printf("point dedant\n");
	      z=calcZ(ppt);
	      ppt->z=z;
	      ppt->idRet=nbrRetPt;
	      if(s->proj) {
		tabRetXY[nbrRetPt][0]=ppt->x;
		tabRetXY[nbrRetPt][1]=ppt->y;
	      } else {
		tabRetXY[nbrRetPt][0]=ppt->x*z;
		tabRetXY[nbrRetPt][1]=ppt->y*z;
	      }
	      tabRetXY[nbrRetPt][2]=z;

	      nbrRetPt++;
	    }
	  }
#endif
	}
      pseg=pseg->next;
    }
   
  }
}

//INLINE 
INLINE static void P3(shadows_t *s,int nbrSeg)
{  
  int i;
  shadows_seg_t *pseg,*nseg;
  shadows_pt_t *ppt;

  //if(dShad) printf("--3--\n");

  /* 3eme parcours : test ints segs */
  
  {
    shadows_ptrseg_t *ptrseg,*ptrseg2;
    shadows_seg_t *nseg2,*pseg2,*psegt,*oldseg;
    shadows_seg_t *tmpseg;
    int cmpt=1,cmpt2=1;
    svec_t x,y;
    svec_t a,b,c;
    //double a,b,c;
    svec_t z;
    register char t;
    //char t2;
    svec_t fc;
    
    psegt=pseg=listSeg.next;
    oldseg=&listSeg;
    
    while(pseg!=NULL) {
      // SPEED ( ^ mask pt au lieu de tester a chaque fois )

      t=0;
      for(i=0;i<nbrSeg;) {
	if(pseg->mask & (1<<i+DECAL_SEGMASK)) {
	  for(nseg=tabInfo[i].seg;nseg!=NULL;) {
	    //printf("nseg=(%f,%f)(%f,%f)\n",nseg->p[0].x,nseg->p[0].y,nseg->p[1].x,nseg->p[1].y);
	    if(nseg->mask) {
	      // FIX
	      // teste si pseg passe par point de nseg
	      
	      //if(INTERSEC_(pseg,nseg)) {
	      //printf("t=%d fcx=%f fcy=%f (%f,%f)(%f,%f)\n",t,fcx,fcy,nseg->p[0].x,nseg->p[0].y,nseg->p[1].x,nseg->p[1].y);
	      if(t==0) a=COTESEGXY_(pseg,nseg->p[0].x,nseg->p[0].y); else a=fc;
	      if( a*(fc=COTESEGXY_(pseg,nseg->p[1].x,nseg->p[1].y)) <= 0.){ 
		//printf("coucou\n");
		if (((b=COTESEGXY_(nseg,pseg->p[0].x,pseg->p[0].y))*
		     (c=COTESEGXY_(nseg,pseg->p[1].x,pseg->p[1].y)) <= 0.) &&
		    (a!=0. || b!=0. || c!=0.)) {
		  // intersection
		  //if(dShad) printf("Intersection\n");
		  pseg->mask &= ~(1<<(i+DECAL_SEGMASK));
		  CALCINTERSEC(pseg,nseg,&x,&y);
		  if(x==nseg->p[0].x && y==nseg->p[0].y) {
		    //printf("cas 1\n");
		    ppt=nseg->p[0].pt;
		  } else if(x==nseg->p[1].x && y==nseg->p[1].y) {
		    //printf("cas 2\n");
		    ppt=nseg->p[1].pt;
		  } else {
		    // FIX attention si ppt deja cree sur pseg
		    // ...
		    // -> nouveau ppt
		    // new nseg (nseg2),et ajouter nseg et nseg2 dans ppt 
		    //printf("cas 3\n");
		    NEWPT(s,ppt);
		    //SPEED
		    ppt->next=NULL;
		    ppt->x=x;
		    ppt->y=y;
		    ppt->nbr=0;
		    // retour
#ifdef SHADOWS_RET_3D
		    if(dShad) printf("point intersection\n");
		    z=calcZ(ppt);
		    ppt->z=z;
		    tabRetXY[nbrRetPt][2]=z;
		    if(s->proj) {
		      tabRetXY[nbrRetPt][0]=ppt->x;
		      tabRetXY[nbrRetPt][1]=ppt->y;
		    } else {  
		      tabRetXY[nbrRetPt][0]=ppt->x*z;
		      tabRetXY[nbrRetPt][1]=ppt->y*z;
		    }
		    ppt->mask2=0;
#else 
		    tabRetXY[nbrRetPt][0]=x;
		    tabRetXY[nbrRetPt][1]=y;
#endif
		    ppt->idRet=nbrRetPt;
		    nbrRetPt++;

		    ppt->mask=PTMASK_1;
		  
		  //ppt->next;
		    NEWSEG(s,nseg2);
		    nseg2->mask=SEGMASK_0;
		    CUTSEG(s,ppt,nseg,nseg2);
		  }
		  // nouveau seg(pseg2) et ajouter pseg et pseg2 dans ppt; 
		  NEWSEG(s,pseg2);
		  pseg2->mask=pseg->mask;
		  CUTSEG(s,ppt,pseg,pseg2);
		  cmpt++;cmpt2++;
		  // SPEED ?
		  t=0;
		  break;
		}
	      }
	      t=1;
	    }
	    else t=0;
	    nseg=nseg->next;
	  }
	}
	else t=0;
	pseg->mask &= ~(1<<(i+DECAL_SEGMASK)); 
	i++;
      }
      
      // SPEED (a enlever ?)
      if(i==nbrSeg) {
	cmpt--;
	if(pseg->mask & (SEGMASK_1|SEGMASK_2) || 
	   ( pseg->p[0].pt->mask & PTMASK_1 && pseg->p[1].pt->mask & PTMASK_1 )) {
	  //if(dShad) printf("Seg In (%f,%f) (%f,%f) m=0x%X\n",pseg->p[0].x,pseg->p[0].y,pseg->p[1].x,pseg->p[1].y,pseg->mask);
	}
	else { 
	  pseg->mask|=SEGMASK_1 | SEGMASK_2;
	}
	pseg=pseg->next;
      }
      
      if(cmpt==0) {
	if(cmpt2==1 && ( psegt->mask & (SEGMASK_1 | SEGMASK_2) ) == (SEGMASK_1 | SEGMASK_2)) {
	  // Seg en dehors du nouveau poly et pas coupe -> on le dechaine
	  //assert(psegt->p[0].zone!=psegt->p[1].zone);
	  psegt->mask=0;
	  if(!(psegt->p[0].pt->mask & PTMASK_1)) {
	    psegt->p[0].pt->mask=0; //&=PTMASK_1;
	  }
#ifdef SHADOWS_RET_3D
	  // SPEED ? passer dans le bloc ?
	  psegt->p[0].pt->mask2=0; //&=PTMASK_1;
#endif
	  if(!(psegt->p[1].pt->mask & PTMASK_1)) {
	    psegt->p[1].pt->mask=0; //&=PTMASK_1;
	  }
#ifdef SHADOWS_RET_3D
	  psegt->p[1].pt->mask2=0; //&=PTMASK_1;
#endif
	  oldseg->next=pseg;
	}
	else {
	  psegt->cmpt=cmpt2;
	  for(;cmpt2>1;cmpt2--) psegt=psegt->next;
	  oldseg=psegt;
	}
	psegt=pseg;
	cmpt=cmpt2=1;
      }
    }
  } 
  
}

INLINE static shadows_ptrseg_t *RECHAINE2_(shadows_t *s,shadows_ptrseg_t *ptrseg,shadows_seg_t *seg,svec_t x,svec_t y)
{
  shadows_ptrseg_t *ptrseg2;
  
  while((x-ptrseg->node->x0)*(x-ptrseg->node->x1) >=0. ||
	(y-ptrseg->node->y0)*(y-ptrseg->node->y1) >=0.) {
    if(x>=ptrseg->node->x0 && x<ptrseg->node->x1 && y>=ptrseg->node->y0 && y<ptrseg->node->y1 )
      return ptrseg;
    //if(dShad) printf("RECHAINE2 (%f,%f)  (%f,%f)(%f,%f)\n",x,y,ptrseg->node->x0,ptrseg->node->y0,ptrseg->node->x1,ptrseg->node->y1);
    if(seg==NULL) { //efface ptrseg
      ptrseg2=ptrseg->aft;
      ptrseg->node->nbrPtrseg--;
      ptrseg->prev->next=ptrseg->next;
      if(ptrseg->next)
	ptrseg->next->prev=ptrseg->prev;
      FREEPTRSEG(s,ptrseg);
      ptrseg=ptrseg2;
    }
    else {
      ptrseg->seg=seg;
      ptrseg=ptrseg->aft;
    }
  }
  return ptrseg;
}

#define RECHAINE2_NULL(s,ptrseg,x,y) { \
  while((x-ptrseg->node->x0)*(x-ptrseg->node->x1) >=0. || \
	(y-ptrseg->node->y0)*(y-ptrseg->node->y1) >=0.) { \
    if(x>=ptrseg->node->x0 && x<ptrseg->node->x1 && y>=ptrseg->node->y0 && y<ptrseg->node->y1 ) \
      break; \
    ptrseg2=ptrseg->aft; \
    ptrseg->node->nbrPtrseg--; \
    ptrseg->prev->next=ptrseg->next; \
    if(ptrseg->next) \
      ptrseg->next->prev=ptrseg->prev; \
    FREEPTRSEG(s,ptrseg); \
    ptrseg=ptrseg2; \
  } \
} \

#define RECHAINE2(s,ptrseg,pseg,x,y) { \
  while((x-ptrseg->node->x0)*(x-ptrseg->node->x1) >=0. || \
	(y-ptrseg->node->y0)*(y-ptrseg->node->y1) >=0.) { \
    if(x>=ptrseg->node->x0 && x<ptrseg->node->x1 && y>=ptrseg->node->y0 && y<ptrseg->node->y1 ) \
      break; \
    ptrseg->seg=pseg; \
    ptrseg=ptrseg->aft; \
  } \
} \

INLINE static void RECHAINE(shadows_t *s,shadows_ptrseg_t *ptrseg,shadows_seg_t *psegt,int cmpt2)
{
  shadows_seg_t *pseg2;
  shadows_ptrseg_t *ptrseg2;
  svec_t x,y;

  for(;cmpt2>0;cmpt2--) {
    if(psegt->mask==0) {

      // SPEED ?
      psegt->p[0].pt->mask=0;
      psegt->p[1].pt->mask=0;
#ifdef SHADOWS_RET_3D
      psegt->p[0].pt->mask2=0;
      psegt->p[1].pt->mask2=0;
#endif

      pseg2=psegt->next;
      //ptrseg=
      x=psegt->p[1].x;
      y=psegt->p[1].y;
      RECHAINE2_NULL(s,ptrseg,x,y);
      if(cmpt2>1) {
	ptrseg->bef=NULL;
      } else {
	ptrseg->prev->next=ptrseg->next;
	ptrseg->node->nbrPtrseg--;
	if(ptrseg->next)
	  ptrseg->next->prev=ptrseg->prev;
	FREEPTRSEG(s,ptrseg);
      }
      FREESEG(s,psegt);
      psegt=pseg2;
    } else {
      psegt->mask=0;
      psegt->p[0].pt->mask=0;
      psegt->p[1].pt->mask=0;
#ifdef SHADOWS_RET_3D
      psegt->p[0].pt->mask2=0;
      psegt->p[1].pt->mask2=0;
#endif

      psegt->ptrseg=ptrseg;
      x=psegt->p[1].x;
      y=psegt->p[1].y;
      //ptrseg=
      RECHAINE2(s,ptrseg,psegt,x,y);
      ptrseg->seg=psegt;
      if(cmpt2>1) {
	NEWPTRSEG(s,ptrseg2);
	ptrseg->node->nbrPtrseg++;
	ptrseg2->node=ptrseg->node;
	
	ptrseg2->next=ptrseg->next;
	ptrseg2->prev=ptrseg;
	if(ptrseg->next)
	  ptrseg->next->prev=ptrseg2;
	ptrseg->next=ptrseg2;
	
	ptrseg2->bef=NULL;
	if(ptrseg2->aft=ptrseg->aft)
	  ptrseg2->aft->bef=ptrseg2;
	
	ptrseg->aft=NULL;

	ptrseg=ptrseg2;
	
      } else {
	ptrseg->aft=NULL;
      }
      psegt=psegt->next;
    }
  }
}

INLINE static void RECHAINE_(shadows_t *s,shadows_ptrseg_t *ptrseg,shadows_seg_t *nseg)
{
  shadows_seg_t *nseg2;
  shadows_ptrseg_t *ptrseg2;
  shadows_pt_t *ppt;
  svec_t x,y;

  while(nseg!=NULL) {
    if(nseg->mask && nseg->p[0].zone==nseg->p[1].zone) {
      //if(dShad) printf("efface nseg (%f,%f) (%f,%f)\n",nseg->p[0].x,nseg->p[0].y,nseg->p[1].x,nseg->p[1].y);
      nseg->mask=0;
      nseg->p[0].pt->mask=0;
      nseg->p[1].pt->mask=0;
#ifdef SHADOWS_RET_3D
      nseg->p[0].pt->mask2=0;
      nseg->p[1].pt->mask2=0;
#endif
      REMOVEPTSEG(s,nseg->p[0].pt,nseg,0);
      REMOVEPTSEG(s,nseg->p[1].pt,nseg,1);
    }

    if(nseg->mask==0) {

      // SPEED ?
      //nseg->p[0].pt->mask=0;
      //nseg->p[1].pt->mask=0;
      //#ifdef SHADOWS_RET_3D
      //psegt->p[0].pt->mask2=0;
      //psegt->p[1].pt->mask2=0;
      //#endif

      nseg2=nseg->next;
      //ptrseg=
      x=nseg->p[1].x;
      y=nseg->p[1].y;
      RECHAINE2_NULL(s,ptrseg,x,y);
      //ptrseg=RECHAINE2(s,ptrseg,NULL,nseg->p[1].x,nseg->p[1].y);
      if(nseg->next!=NULL) {
	ptrseg->bef=NULL;
      } else {
	ptrseg->node->nbrPtrseg--;
	ptrseg->prev->next=ptrseg->next;
	if(ptrseg->next)
	  ptrseg->next->prev=ptrseg->prev;
	FREEPTRSEG(s,ptrseg);
      }
      FREESEG(s,nseg);
      nseg=nseg2;
    } else {
      
      // SPEED 
      if((ppt=nseg->p[0].pt)->next==NULL) {
	//if(dShad) printf("lala 1\n");
	ppt->next=ptrseg->node->pt.next;
	ppt->prev=&ptrseg->node->pt;
	ptrseg->node->pt.next->prev=ppt;
	ptrseg->node->pt.next=ppt;
      }

      nseg->id=MAX_NSEG;
      nseg->mask=0;
      nseg->p[0].pt->mask=0;
      nseg->p[1].pt->mask=0;
#ifdef SHADOWS_RET_3D
      nseg->p[0].pt->mask2=0;
      nseg->p[1].pt->mask2=0;
#endif
      
      nseg->ptrseg=ptrseg;
      x=nseg->p[1].x;
      y=nseg->p[1].y;
      //ptrseg=
      RECHAINE2(s,ptrseg,nseg,x,y);
      //ptrseg=RECHAINE2(s,ptrseg,nseg,nseg->p[1].x,nseg->p[1].y);
      ptrseg->seg=nseg;
      if(nseg->next!=NULL) {
	NEWPTRSEG(s,ptrseg2);
	ptrseg->node->nbrPtrseg++;
	ptrseg2->node=ptrseg->node;
	
	ptrseg2->next=ptrseg->next;
	ptrseg2->prev=ptrseg;
	if(ptrseg->next)
	  ptrseg->next->prev=ptrseg2;
	ptrseg->next=ptrseg2;
	
	ptrseg2->bef=NULL;
	if(ptrseg2->aft=ptrseg->aft)
	  ptrseg2->aft->bef=ptrseg2;
	ptrseg->aft=NULL;

	ptrseg=ptrseg2;
	
      } else {
	ptrseg->aft=NULL;
      }

      // SPEED
      if((ppt=nseg->p[1].pt)->next==NULL) {
	//if(dShad) printf("lala 2\n");
	ppt->next=ptrseg->node->pt.next;
	ppt->prev=&ptrseg->node->pt;
	ptrseg->node->pt.next->prev=ppt;
	ptrseg->node->pt.next=ppt;
      }
      nseg=nseg->next;
    }
  }
}

//INLINE 
INLINE static void P4(shadows_t *s,int nbrSeg)
{
  int i,j;

  shadows_seg_t *nseg,*pseg;
  //shadows_pt_t *ppt;
  //shadows_node_t *pnode;

  //svec_t x,y,ox,oy;

  //char cote,ctmp;
  
  //mask_t m;

  //if(dShad) printf("--4--\n");

  //for(i=0;i<nbrSeg;i++) {
  //  printf("%d: m=0x%d %p %p\n",i,tabInfo[i].seg->mask,tabInfo[i].seg->p[0].pt,tabInfo[i].seg->p[1].pt);
  //}

  /* 4eme passe */
  {
    shadows_seg_t *psegt,*pseg2;
    shadows_ptrseg_t *ptrseg,*ptrseg2;
    int cmpt,cmpt2;
    // psegt=
    pseg=listSeg.next;
    //if(pseg)
    //  cmpt2=cmpt=pseg->cmpt;
    while(pseg!=NULL) {
      
      //if(dShad) printf("4- (%f,%f) (%f,%f)\n",pseg->p[0].x,pseg->p[0].y,pseg->p[1].x,pseg->p[1].y);

      // Parcours polys
      if((pseg->mask & SEGMASK_1 )== 0) {
	PARCOURS(pseg,0,pseg->p[0].zone,Zone);
      }
      if((pseg->mask & SEGMASK_2 )== 0) {
	PARCOURS(pseg,1,pseg->p[1].zone,Zone);
      }
      pseg=pseg->next;
    }

  
  /* Teste si nseg ok */
  
    i=0;nseg=tabInfo[i].seg;
    while(i!=nbrSeg && nseg->mask==0) (nseg=nseg->next) || (i++,((i<nbrSeg) && (nseg=tabInfo[i].seg)));
    if(nseg && !(nseg->mask & SEGMASK_2)) {
      zone_t z;
      if(ppt_complet) {
	{
	  char cote=ppt_complet->cote,ctmp,a=0;
	  shadows_seg_t *psegt=ppt_complet->seg;
	  for(;;) {
	    if(psegt->id==MAX_NSEG) {
	      //if(!(psegt->mask & SEGMASK_NEW)) {
	      a=1;
	      z=psegt->p[cote].zone;
	    } else if(a==1) {
	      break;
	    }
	    ctmp=psegt->p[cote].nextCote;
	    psegt=psegt->p[cote].next;
	    cote=ctmp;
	  }
	} 
      } else {
	z=checkpoint(s,minNodeCheck,minZoneCheck,minPtCheck->x,minPtCheck->y);
      }
      if(dShad) printf("P--\n");
      PARCOURS(nseg,1,z,Zone);
    }
      
  
    psegt=pseg=listSeg.next;
    if(pseg)
      cmpt2=cmpt=pseg->cmpt;
    while(pseg!=NULL) {
      if(pseg->p[0].zone==pseg->p[1].zone) {
	//if(dShad) printf("efface seg (%f,%f) (%f,%f)\n",pseg->p[0].x,pseg->p[0].y,pseg->p[1].x,pseg->p[1].y);
	REMOVEPTSEG(s,pseg->p[0].pt,pseg,0);
	REMOVEPTSEG(s,pseg->p[1].pt,pseg,1);
	pseg->mask=0;
      }
      pseg=pseg->next;
      cmpt--;
      if(cmpt==0) {
	// Rechainer ptrseg;
	if(cmpt2>1 | psegt->mask==0) {
	  //if(dShad) printf("rechainage seg\n");
	  ptrseg=psegt->ptrseg;
	  RECHAINE(s,ptrseg,psegt,cmpt2);
	  psegt=pseg;
	} else {
	  psegt->mask=0;
	  psegt->p[0].pt->mask=0;
	  psegt->p[1].pt->mask=0;
#ifdef SHADOWS_RET_3D
	  psegt->p[0].pt->mask2=0;
	  psegt->p[1].pt->mask2=0;
#endif
	  psegt=pseg;
	}

	if(pseg)
	  cmpt=cmpt2=pseg->cmpt;
      }
    }
    

    // Retour
    //...
   
    /*
    printf("retour: %d polys, %d points\n",nbrRetPoly,nbrRetPt);
    for(i=0;i<nbrRetPoly;i++) {
      shadows_seg_2_t *seg_2;
      printf("zone=%d : ",tabRet[i].zone);
      seg_2=tabRet[i].seg_2;
      do {
	printf("(%f,%f) ",tabRetXY[seg_2->pt->idRet][0],tabRetXY[seg_2->pt->idRet][1]);
	seg_2=seg_2->nextP;
      } while(seg_2!=tabRet[i].seg_2);
      printf("\n");
      }*/

    nbrRet=shadows_triangulate(tabRet,nbrRetPoly,/*tabRetXY,nbrRetPt,*/nbrRetHole,tabRetPoly,tabRetId);
  }

  /** MAJ nouveaux segs **/
  // FIX
  {
    // maj ptrseg
    shadows_seg_t *nsegt;
    shadows_ptrseg_t *ptrseg;

    for(i=0;i<nbrSeg;i++) {
      nseg=tabInfo[i].seg;
      
      ptrseg=tabInfo[i].ptrseg;
      RECHAINE_(s,ptrseg,nseg);
    }
  }
}  

INLINE void PP(shadows_t *s,int nbrSeg)
{
  shadows_seg_t *pseg,*nseg,*pseg2;
  shadows_pt_t *ppt;

  int i,j;
  mask_t m;
  char ctmp,cote;
  

  // Chaine avec les points
  
  nseg=tabInfo[nbrSeg-1].seg;
  for(i=0;i<nbrSeg;i++) {
    pseg=tabInfo[i].seg;
    if((ppt=tabInfo[i].pt)->nbr!=0) {
      if(i) m=~(0x3<<i-1+DECAL_SEGMASK);
      else m=~((1 << DECAL_SEGMASK) |(1<<(nbrSeg-1+DECAL_SEGMASK)));
      for(j=0,pseg2=ppt->seg,cote=ppt->cote;j<ppt->nbr;j++) {
	pseg2->mask&=m;
	ctmp=pseg2->p[cote].nextCote;
	pseg2=pseg2->p[cote].next;
	cote=ctmp;
      }
      ppt->mask=PTMASK_1;
      ppt->idRet=i;
#ifdef SHADOWS_RET_3D
      ppt->z=tabInfo[i].z;
      // FIX ?
      ppt->mask2=0; //PTMASK2_0;
#endif
      ADDPTSEG(s,ppt,pseg,0);
      ADDPTSEG(s,ppt,nseg,1);
      nseg=pseg;
    }
    else {
      ppt->nbr=2;
      ppt->idRet=i;
      ppt->mask=PTMASK_1;
#ifdef SHADOWS_RET_3D
      ppt->z=tabInfo[i].z;
      //ppt->mask2=PTMASK2_0;
#endif
      pseg->p[0].next=pseg->p[0].prev=nseg;
      pseg->p[0].nextCote=pseg->p[0].prevCote=1;
      pseg->p[0].pt=nseg->p[1].pt=ppt;
      nseg->p[1].next=nseg->p[1].prev=pseg;
      nseg->p[1].nextCote=nseg->p[1].prevCote=0;
      if(pseg->p[0].tet < nseg->p[1].tet) {
	ppt->seg=pseg;
	ppt->cote=0;
      } else {
	ppt->seg=nseg;
	ppt->cote=1;
      }
      nseg=pseg;
    }
  }
}

/* Rajoute un polygone a l'ombre */
#ifdef SHADOWS_RET_3D
int shadows_addPoly(shadows_t *s,float vertex[][3],int face[],int n,zone_t zone,svec3_t **tabRetXY_,int **tabRetId_,shadows_ret_t **tabRetPoly_,int *nbrRetPt_)
#else
int shadows_addPoly(shadows_t *s,float vertex[][2],int face[],int n,zone_t zone)
#endif
{
  int nbrSeg=0;
  int i,j,k,d;

  //shadows_seg_t listSeg;
  shadows_seg_t *nseg,*pseg,*pseg2;
  shadows_pt_t *ppt;
  shadows_node_t *pnode;

  // FIX ifdef ret3d
  float tabPtXY[MAX_NSEG][2];
  char tabPt[MAX_NSEG];
  //shadows_pt_t *ppt_complet=NULL;
  shadows_ptrseg_t *tabPtrseg[MAX_NSEG][2];

  svec_t minx,miny,maxx,maxy;
  svec_t totalaera;
  svec_t x,y;
  svec_t ox,oy;
  svec_t tet;
  svec_t x_,y_;
  svec_t z,oz;

  char cote,ctmp;
  
  mask_t m;
  
  //if (dShad) printf("-----------\n");
  //stat[0]=stat[1]=stat[2]=0;
  //verInt(&s->node);
  
  //if(dShad) for(i=0;i<n;i++) printf("(%f,%f)\n",POLY_X(i),POLY_Y(i));
  
  /** Traitement poly **/
  // ! tester sens du poly, convexite 
  
  {
    //FIX
    float x,y,ox,oy,x_,y_;
#ifdef SHADOWS_RET_3D
  if(!s->proj) {
    x_=ox=POLY_X(n-1)/POLY_Z(n-1);
    y_=oy=POLY_Y(n-1)/POLY_Z(n-1);
  } else 
#endif
    {
      x_=ox=POLY_X(n-1);
      y_=oy=POLY_Y(n-1);
    } 
  
  for(i=0;i<n;i++) {
    if(i<n-1){
#ifdef SHADOWS_RET_3D
      if(!s->proj) {
	x=POLY_X(i)/POLY_Z(i);
	y=POLY_Y(i)/POLY_Z(i);
      } else 
#endif
	{
	  x=POLY_X(i);
	  y=POLY_Y(i);
	}
    } else {
      x=x_;
      y=y_;
    }
    if(ox!=x || oy!=y) {
      tabPt[nbrSeg]=i;
      tabPtXY[nbrSeg][0]=x;
      tabPtXY[nbrSeg][1]=y;
      
      if(nbrSeg==0) {
	minx=maxx=x;
	miny=maxy=y;
	totalaera=x*oy-y*ox;
      }
      else {
	if(minx>x) minx=x;
	else if(maxx<x) maxx=x;
	if(miny>y) miny=y;
	else if(maxy<y) maxy=y;
	totalaera+=x*oy-y*ox;
      }
      
      nbrSeg++;
      ox=x;oy=y;
    }
    // FIX
    else return 0;
  }
  }

  //if(totalaera<=0) return 0;
  //RCH=0; //return 0;
  //else RCH=1;

#ifdef SHADOWS_FACE_ONLY
  if(nbrSeg < 3 || totalaera<=0.) return 0;
#else
  if(nbrSeg < 3 || totalaera==0.) return 0;
#endif
  
  ppt_complet=NULL;

  //SPEED
  Zone=zone;
  minNbrSegCheck=-1;

  listSeg.next=NULL;

  //FIX retour
  nbrRetPt=nbrSeg;
  nbrRetPoly=0;
  nbrRetHole=0;
 
#ifndef SHADOWS_FACE_ONLY
  if(totalaera<0.) {
    d=-1;
    totalaera=-totalaera;
  } else
#endif
    d=1;
  ox=tabPtXY[0][0];//POLY_X(tabPt[0]);
  oy=tabPtXY[0][1];//POLY_Y(tabPt[0]);
#ifdef SHADOWS_RET_3D
  oz=POLY_Z(tabPt[0]);
#endif
  j=0;
  for(i=0;i<nbrSeg;i++) {
    NEWSEG(s,pseg);
    tabInfo[i].seg=pseg;
    tabInfo[i].pt=NULL;
#ifdef SHADOWS_RET_3D
    pseg->p[0].x=tabInfo[i].x=ox; //POLY_X(tabPt[j]);//tabPtXY[j][0];
    pseg->p[0].y=tabInfo[i].y=oy; //POLY_Y(tabPt[j]);//tabPtXY[j][1];
    tabRetXY[i][0]=POLY_X(k=tabPt[j]);
    tabRetXY[i][1]=POLY_Y(k);
    tabInfo[i].z=tabRetXY[i][2]=oz;
#else
    tabRetXY[i][0]=pseg->p[0].x=tabInfo[i].x=ox; //POLY_X(tabPt[j]);//tabPtXY[j][0];
    tabRetXY[i][1]=pseg->p[0].y=tabInfo[i].y=oy; //POLY_Y(tabPt[j]);//tabPtXY[j][1];
#endif
    j+=d;
    if(j==nbrSeg) j=0;
#ifndef SHADOWS_FACE_ONLY
    else if(j<0) j=nbrSeg-1;
#endif
    //j=(j+nbrSeg+d)%nbrSeg;
    pseg->p[1].x=x=tabPtXY[j][0];//POLY_X(tabPt[j]);//tabPtXY[j][0];
    pseg->p[1].y=y=tabPtXY[j][1];//POLY_Y(tabPt[j]);//tabPtXY[j][1];
#ifdef SHADOWS_RET_3D
    z=POLY_Z(tabPt[j]);
#endif
    // FIX ? (pour nodes)
    if(ox > x || (x==ox && oy < y)) {
      pseg->sens=0;
      pseg->xo0=x;
      pseg->xo1=ox;
      pseg->yo0=y;
      pseg->yo1=oy;
#ifdef SHADOWS_RET_3D
      pseg->zo0=z;
      pseg->zo1=oz;
#endif
      x_=ox-x;
      y_=oy-y;

      if(x_>=fabs(y_))
	tet=1.+y_/x_;
      else
	if(y_>=0)
	  tet=3.-x_/y_;
	else
	  tet=7.-x_/y_;
      
      pseg->p[1].tet=tet;
      if(tet>=4.)
	pseg->p[0].tet=tet-4.;
      else 
      pseg->p[0].tet=tet+4.;
    } else {
      pseg->sens=1;
      pseg->xo0=ox;
      pseg->xo1=x;
      pseg->yo0=oy;
      pseg->yo1=y;
#ifdef SHADOWS_RET_3D
      pseg->zo0=oz;
      pseg->zo1=z;
#endif
      x_=x-ox;
      y_=y-oy;

      if(x_>=fabs(y_))
	tet=1.+y_/x_;
      else
	if(y_>=0)
	  tet=3.-x_/y_;
	else
	  tet=7.-x_/y_;
      
      pseg->p[0].tet=tet;
      if(tet>=4.)
	pseg->p[1].tet=tet-4.;
      else 
	pseg->p[1].tet=tet+4.;
    }  
  
    //SPEED
    pseg->id=i;
    //pseg->mask=SEGMASK_0 | SEGMASK_NEW;
    pseg->mask=SEGMASK_0;
    pseg->next=NULL;
    //SPEED
    pseg->p[0].pt=pseg->p[1].pt=NULL;
    //SPEED
    pseg->ptrseg=NULL;

    ox=x;oy=y;
#ifdef SHADOWS_RET_3D
    oz=z;
#endif
  }
  
  // FIX A VIRER
  //*tabRetXY_=tabRetXY;
  //return 1;

#ifdef SHADOWS_RET_3D
  initCalcZ(tabRetXY,s->proj);
#endif

  /** Parcours l'arbre **/
  // Appel fonction recursive
  {
    pnode=&(s->node);
    i=0;
    while(pnode->nbrPtrseg<0 && i==0) {
      j=0;
      if (minx >= (x=pnode->fils[0]->x1)) j++;
      else if(maxx >= x) i=1;
      if (miny >= (y=pnode->fils[0]->y1)) j+=2;
      else if(maxy >= y) i=1;
      if (!i) { 
	pnode=pnode->fils[j];
	if(dShad) printf("prerec: j=%d\n",j);
      }
    }
    
    rec(s,pnode,nbrSeg,((1<<nbrSeg)-1),((1<<nbrSeg)-1),tabInfo,tabPtrseg,minx,miny,maxx,maxy);
    
    for(i=0;i<nbrSeg;i++) {
      tabInfo[i].ptrseg=tabPtrseg[i][0]; 
      tabPtrseg[i][1]->aft=NULL;
      tabPtrseg[i][0]->bef=NULL;
    }

    // verInt2(&s->node);
  }
  
  if(dShad) XX(s);

  P1(s,nbrSeg);

  PP(s,nbrSeg);

  P2(s,nbrSeg);
  P3(s,nbrSeg);
  
  if(dShad) XX(s);
  P4(s,nbrSeg);

#ifdef SHADOWS_RET_3D
  // FIX SPEED
  *tabRetXY_=tabRetXY;
  *tabRetId_=tabRetId;
  *tabRetPoly_=tabRetPoly;
  *nbrRetPt_=nbrRetPt;
#endif
  
  if(dShad) printf("nbrRetPt=%d nbrRetPoly=%d poly[0].nbr=%d\n",nbrRetPt,nbrRet,tabRetPoly[0].nbr);

  return nbrRet;
}
  
INLINE static zone_t checkpoint(shadows_t *s,shadows_node_t *node,zone_t zone,svec_t x,svec_t y)
{
  shadows_seg_t psedo;
  shadows_ptrseg_t *ptrseg;
  shadows_seg_t *psegm=NULL,*pseg;
  svec_t xm,ym,fc,x_,y_;
  
  psedo.p[0].x=psedo.xo0=node->x0;
  psedo.p[0].y=psedo.yo0=node->y0;
  psedo.p[1].x=psedo.xo1=x;
  psedo.p[1].y=psedo.yo1=y;
  ptrseg=node->ptrseg.next;
  while(ptrseg!=NULL)  {
    if(pseg=ptrseg->seg) {
      if(INTERSEC(pseg,&psedo)){
	if(psegm==NULL) {
	  psegm=pseg;
	  CALCINTERSEC(pseg,&psedo,&xm,&ym);
	} else {
	  CALCINTERSEC(pseg,&psedo,&x_,&y_);
	  if((x_-xm)*(x_-x) <=0. &&
	     (y_-ym)*(y_-y) <=0.) {
	    if(x_==xm && y_==ym) {
	      // FIX
	      // ...
	      assert(0);
	    } else {
	      xm=x_;ym=y_;
	      psegm=pseg;
	    }
	  }
	}
      }
    }
    ptrseg=ptrseg->next;
  }
  if(psegm==NULL) 
    return zone;
  if((fc=COTESEGXY2(psegm,x,y))>0.)
    return(psegm->p[1].zone);
  // SPEED
  else if(fc<0.)
    return(psegm->p[0].zone);
  else {
    printf("checkPoint sur seg");
    return (NOZONE);
  }
}
 
zone_t shadows_checkPoint(shadows_t *s,svec_t x,svec_t y)
{
  shadows_node_t *node=&s->node;
  int i;

  while(node->nbrPtrseg<0) {
    i=0;
    if(x>=node->fils[0]->x1) i++;
    if(y>=node->fils[0]->y1) i+=2;
    node=node->fils[i];
  }

  return checkpoint(s,node,node->zone,x,y);
}

