/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* 29/07/00 */

#ifndef _SHADOWS_H
#define _SHADOWS_H

//FIX
extern int RCH;

//FIX
#define SHADOWS_NODE_FLS 400
#define SHADOWS_SEG_FLS 1000
#define SHADOWS_PTRSEG_FLS 1000
#define SHADOWS_PT_FLS 1000

#define SHADOWS_RET_3D
#define SHADOWS_FACE_ONLY
#define SHADOWS_TRIANGULATE

/* rgb et texture */
/*
typedef struct {
  char r,g,b,t;
} zone_t;
*/

/* sur 7 bits */
typedef unsigned char zone_t;
#define NOZONE 128
//#defibe ZONE_NORET 0
#define ADDZONE(a,b) (((unsigned short)(a)*(b))>>7)
//#define ZONENORET(z) ((z)==0)
#define ZONENORET(z) (0)

typedef unsigned short int mask_t; 

typedef double svec_t;
//typedef float svec_t;
typedef svec_t svec3_t[3];

struct shadows_ptrseg_s;
struct shadows_pt_s;
struct shadows_seg_s;
struct shadows_node_s;

typedef struct shadows_seg_2_s {
  svec_t x,y; //OPT
  svec_t tet;
  struct shadows_seg_s *next,*prev;
  struct shadows_pt_s *pt;
  struct shadows_seg_2_s *nextP,*prevP; // pour retour
  zone_t zone;
  char nextCote,prevCote;
  char concave; 
} shadows_seg_2_t;

typedef struct shadows_seg_s {
  svec_t xo0,yo0,xo1,yo1;
#ifdef SHADOWS_RET_3D
  svec_t zo0,zo1;
#endif
  int id; // char
  int cmpt; // char
  char sens; 
  struct shadows_seg_s *next;
  struct shadows_ptrseg_s *ptrseg;
  mask_t mask;
  shadows_seg_2_t p[2];
} shadows_seg_t;

typedef struct shadows_pt_s {
  int nbr; // short ou char
  svec_t x,y;
#ifdef SHADOWS_RET_3D
  svec_t z; // oz
  mask_t mask2;
#endif
  shadows_seg_t *seg;
  char cote;
  struct shadows_pt_s *next,*prev;
  mask_t mask;
  int idRet;
} shadows_pt_t;

typedef struct shadows_ptrseg_s
{
  struct shadows_node_s *node;
  struct shadows_seg_s *seg;
  struct shadows_ptrseg_s *bef,*aft,*next,*prev;
} shadows_ptrseg_t;

typedef struct shadows_node_s
{
  svec_t x0,y0,x1,y1;
  zone_t zone;
  signed int nbrPtrseg;
  struct shadows_node_s *fils[4];
  struct shadows_ptrseg_s ptrseg;
  struct shadows_pt_s pt;
  struct shadows_node_s *next; /* pour freelist */ // OPT
} shadows_node_t;

typedef struct shadows_s
{
  shadows_seg_t *tabSeg;
  shadows_seg_t *freeSeg;
  int sizeTabSeg;

  shadows_node_t *tabNode;
  shadows_node_t *freeNode;
  int sizeTabNode;

  shadows_ptrseg_t *tabPtrseg;
  shadows_ptrseg_t *freePtrseg;
  int sizeTabPtrseg;

  shadows_pt_t *tabPt;
  shadows_pt_t *freePt;
  int sizeTabPt;
  
  shadows_node_t node;
  
  int proj;
} shadows_t;

typedef struct shadows_poly_s {
  zone_t zone;
  shadows_seg_2_t *seg_2;
  int hole; //char
  int concave; //char
} shadows_poly_t;

typedef struct shadows_ret_s {
  zone_t zone;
  int nbr;
  int start;
} shadows_ret_t;

extern shadows_t *shadows_create(zone_t zone,int proj);
extern void shadows_destroy(shadows_t *shadow);
extern void shadows_erase(shadows_t *shadow,zone_t zone,int proj);
// proj == 1 -> projection parallele

#ifdef SHADOWS_RET_3D
extern int shadows_addPoly(shadows_t *s,float vertex[][3],int face[],int n,zone_t zone,svec3_t **tabRetXY_,int **tabRetId_,shadows_ret_t **tabRetPoly_,int *nbrRetPt_);
#else
extern int shadows_addPoly(shadows_t *s,float vertex[][2],int face[],int n,zone_t zone);
#endif

extern zone_t shadows_checkPoint(shadows_t *s,svec_t x,svec_t y);

/*
extern void node_cut(shadows_t *s,shadows_node_t *node);
extern void node_merge(shadows_t *s,shadows_node_t *node);
*/

//extern void shadows_copy(shadows_t *dest,shadows_t *src);
//extern shadows_t *shadow_copyCreate(shadows_t *src);
//add shadow
//checkPoint,checkPoly

#endif
