/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

INLINE static void INIT_SHAD(shadows_t *p,zone_t zone,int proj) { 
  int i;

  p->freeSeg=p->tabSeg;
  p->sizeTabSeg=SHADOWS_SEG_FLS;
  for(i=0;i<(SHADOWS_SEG_FLS-1);i++) {
    p->tabSeg[i].next=&(p->tabSeg[i+1]);
    p->tabSeg[i].mask=0x1;
  }
  
  p->freeNode=p->tabNode; 
  p->sizeTabNode=SHADOWS_NODE_FLS;
  for(i=0;i<(SHADOWS_NODE_FLS-1);i++) 
    p->tabNode[i].next=&(p->tabNode[i+1]); 
  
  p->freePtrseg=p->tabPtrseg; 
  p->sizeTabPtrseg=SHADOWS_PTRSEG_FLS; 
  for(i=0;i<(SHADOWS_PTRSEG_FLS-1);i++) 
    p->tabPtrseg[i].next=&(p->tabPtrseg[i+1]); 
  
  p->freePt=p->tabPt; 
  p->sizeTabPt=SHADOWS_PT_FLS; 
  for(i=0;i<(SHADOWS_PT_FLS-1);i++) { 
    p->tabPt[i].next=&(p->tabPt[i+1]); 
    p->tabPt[i].mask=0x0; 
  } 
 
  p->node.x0=p->node.y0=-2.; 
  p->node.x1=p->node.y1=2.; 
  p->node.zone=zone; 
  for(i=0;i<4;i++) 
    p->node.fils[i]=NULL; 
  p->node.ptrseg.next=NULL; 
  p->node.ptrseg.prev=NULL; /*SPEED*/
  p->node.nbrPtrseg=0; 

  p->node.pt.next=p->node.pt.prev=&p->node.pt;

  p->proj=proj;
} 

#define AFFDEF(s) printf(#s " = %d\n",s)

/* cree une structure ombre */
shadows_t *shadows_create(zone_t zone,int proj)
{
  shadows_t *p;
  
  printf(__TIME__ " " __DATE__ " \n");
  AFFDEF(SHADOWS_NODE_FLS);
  AFFDEF(SHADOWS_SEG_FLS);
  AFFDEF(SHADOWS_PTRSEG_FLS);
  AFFDEF(SHADOWS_PT_FLS);
  
  if((p=(shadows_t*)calloc(1,sizeof(shadows_t)))==NULL) error();
  if((p->tabSeg=(shadows_seg_t*)calloc(SHADOWS_SEG_FLS,sizeof(shadows_seg_t)))==NULL) error();
  if((p->tabNode=(shadows_node_t*)calloc(SHADOWS_NODE_FLS,sizeof(shadows_node_t)))==NULL) error();
  if((p->tabPtrseg=(shadows_ptrseg_t*)calloc(SHADOWS_PTRSEG_FLS,sizeof(shadows_ptrseg_t)))==NULL) error();
  if((p->tabPt=(shadows_pt_t*)calloc(SHADOWS_PT_FLS,sizeof(shadows_pt_t)))==NULL) error();
  
  INIT_SHAD(p,zone,proj);
  
  return p;
}

/* detruit une structure ombre */
void shadows_destroy(shadows_t *p)
{
  free((void*)p->tabNode);
  free((void*)p->tabSeg);
  free((void*)p->tabPtrseg);
  free((void*)p);
}

/* efface une ombre */
void shadows_erase(shadows_t *p,zone_t zone,int proj)
{
  //FIX
  /*
  if((p->tabSeg=(shadows_seg_t*)realloc(p->tabSeg,SHADOWS_SEG_FLS*sizeof(shadows_seg_t)))==NULL) error();
  if((p->tabNode=(shadows_node_t*)realloc(p->tabNode,SHADOWS_NODE_FLS*sizeof(shadows_node_t)))==NULL) error();
  if((p->tabPtrseg=(shadows_ptrseg_t*)realloc(p->tabPtrseg,SHADOWS_PTRSEG_FLS*sizeof(shadows_ptrseg_t)))==NULL) error();
  if((p->tabPt=(shadows_pt_t*)realloc(p->tabPt,SHADOWS_PT_FLS*sizeof(shadows_pt_t)))==NULL) error();
  */

  INIT_SHAD(p,zone,proj);
}
