/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**** NODES ****/

int stat_rec[2]={0,0};

#define M0 0x1B 
#define M1 0x36 
#define M2 0xD8 
#define M3 0x1B0 

#define ADDPTRSEGNODE(pnode,pptrseg) { \
  pnode->nbrPtrseg++; \
  pptrseg->node=pnode; \
  pptrseg->next=pnode->ptrseg.next; \
  pptrseg->prev=&pnode->ptrseg; \
  if(pnode->ptrseg.next) \
    pnode->ptrseg.next->prev=pptrseg; \
  pnode->ptrseg.next=pptrseg; \
} \

/* decoupe un node */
//INLINE 
static void node_cut(shadows_t *s,shadows_node_t *node)
{
  int i,j,k;
  char l[4];
  svec_t x,y,x0,y0,x1,y1;
  svec_t x_,y_,x0_,y0_,x1_,y1_;
  svec_t dx,dy;
  shadows_pt_t *ppt,*ppt2,*pptt;
  shadows_ptrseg_t *ptrseg,*ptrsegt,*ptrseg2;
  shadows_seg_t *seg;
  unsigned short m;
  svec_t dm,d;
  int km;
  
  for(j=0;j<4;j++) {
    NEWNODE(s,node->fils[j]);
    node->fils[j]->pt.next=node->fils[j]->pt.prev=&node->fils[j]->pt;
    node->fils[j]->ptrseg.next=NULL;
    node->fils[j]->nbrPtrseg=0;
  }
  
  node->fils[0]->x0=node->fils[2]->x0=x0=node->x0;
  node->fils[1]->x1=node->fils[3]->x1=x1=node->x1;
  node->fils[0]->y0=node->fils[1]->y0=y0=node->y0;
  node->fils[2]->y1=node->fils[3]->y1=y1=node->y1;
  node->fils[0]->x1=node->fils[2]->x1=node->fils[1]->x0=node->fils[3]->x0=x=(node->x0+node->x1)/2.;
  node->fils[0]->y1=node->fils[1]->y1=node->fils[2]->y0=node->fils[3]->y0=y=(node->y0+node->y1)/2.;
  
  // zones
  node->fils[0]->zone=node->zone;
  node->fils[1]->zone=checkpoint(s,node,node->zone,x,y0);
  node->fils[2]->zone=checkpoint(s,node,node->zone,x0,y);
  node->fils[3]->zone=checkpoint(s,node,node->zone,x,y);
    
  // points
  ppt=node->pt.next;
  while(ppt!=&node->pt) {
    j=0;
    if(ppt->x>=x) j++;
    if(ppt->y>=y) j+=2;
    ppt2=&node->fils[j]->pt;
    pptt=ppt->next;
    ppt->next=ppt2->next;
    ppt->prev=ppt2;
    ppt2->next->prev=ppt;
    ppt2->next=ppt;
    ppt=pptt;
  }

  // ptrsegs
  ptrseg=node->ptrseg.next;
  while(ptrseg!=NULL) {
    
    // SPEED  super caca

    m=0;
    i=0;
    seg=ptrseg->seg;

    dx=seg->xo1-seg->xo0;
    dy=seg->yo1-seg->yo0;
    x_=(x-seg->xo0)*dy;
    x0_=(x0-seg->xo0)*dy;
    x1_=(x1-seg->xo0)*dy;
    y_=(y-seg->yo0)*dx;
    y0_=(y0-seg->yo0)*dx;
    y1_=(y1-seg->yo0)*dx;
    
    if(y0_<x0_) m|=1;
    if(y0_<x_) m|=2;
    if(y0_<x1_) m|=4;
    if(y_<x0_) m|=8;
    if(y_<x_) m|=16;
    if(y_<x1_) m|=32;
    if(y1_<x0_) m|=64;
    if(y1_<x_) m|=128;
    if(y1_<x1_) m|=256;
    
    ptrsegt=ptrseg->next;
    
    if ((m & M0) && ((m & M0) != M0) &&
	(seg->p[0].x < x || seg->p[1].x < x) &&
	(seg->p[0].y < y || seg->p[1].y < y))  { 
      i++;k=0;
      l[0]=1; 
    }
    else 
      l[0]=0;

    if ((m & M1) && ((m & M1) != M1) &&
	(seg->p[0].x >= x || seg->p[1].x >= x) &&
	(seg->p[0].y < y || seg->p[1].y < y))  { 
      i++;k=1;
      l[1]=1; 
    }
    else 
      l[1]=0;
    
    if ((m & M2) && ((m & M2) != M2) &&
	(seg->p[0].x < x || seg->p[1].x < x) &&
	(seg->p[0].y >= y || seg->p[1].y >= y))  { 
      i++;k=2;
      l[2]=1; 
    }
    else 
      l[2]=0;

    if ((m & M3) && ((m & M3) != M3) &&
	(seg->p[0].x >= x || seg->p[1].x >= x) &&
	(seg->p[0].y >= y || seg->p[1].y >= y))  { 
      i++;k=3;
      l[3]=1; 
    }
    else 
      l[3]=0;

    //assert(i>=1 && i<=3);

    if(i==1) {
      ADDPTRSEGNODE(node->fils[k],ptrseg);
    } else {
      //SPEED (passer var en local de la fnct)
      km=-1;
      for(k=0;k<4;k++) {
	if(l[k]) {
	  d=(seg->p[1].x-seg->p[0].x)*(node->fils[k]->x0-seg->p[0].x)+
	    (seg->p[1].y-seg->p[0].y)*(node->fils[k]->y0-seg->p[0].y);
	  if(km==-1 || d<dm) {
	    km=k;
	    dm=d;
	  }
	}

      }

      //assert(km!=-1);

      ADDPTRSEGNODE(node->fils[km],ptrseg);

      m=1;
      k=km ^ m;
      if(!l[k]) m^=3;
      k=km ^ m;

      //assert(l[k]);

      NEWPTRSEG(s,ptrseg2);
      ptrseg2->aft=ptrseg->aft;
      ptrseg2->bef=ptrseg;
      if(ptrseg->aft)
	ptrseg->aft->bef=ptrseg2;
      ptrseg->aft=ptrseg2;
      ptrseg2->seg=seg;
      ADDPTRSEGNODE(node->fils[k],ptrseg2);

      m^=3;
      km=k^m;

      //assert((i==3 && l[km]) || (i==2 && !l[km])); 

      if(l[km]) {
	// SPEED
	ptrseg=ptrseg2;
	NEWPTRSEG(s,ptrseg2);
	ptrseg2->aft=ptrseg->aft;
	ptrseg2->bef=ptrseg;
	if(ptrseg->aft)
	  ptrseg->aft->bef=ptrseg2;
	ptrseg->aft=ptrseg2;
	ptrseg2->seg=seg;
	ADDPTRSEGNODE(node->fils[km],ptrseg2);
      }
    }
    ptrseg=ptrsegt;
  }
  
  node->nbrPtrseg=-1;
}

/* fusionne 4 fils d'un node */
//INLINE 
static void node_merge(shadows_t *s,shadows_node_t *node)
{
  int i=0,j;
  svec_t x0,y0,x1,y1;
  shadows_ptrseg_t *ptrseg,*ptrseg2=&node->ptrseg,*ptrsegtmp;
  shadows_node_t *n;
  shadows_pt_t *ppt;
  ptrseg2->next=NULL;

  //assert(node->nbrPtrseg<0);
  //assert(node->fils[0]->nbrPtrseg>=0 && node->fils[1]->nbrPtrseg>=0 && node->fils[2]->nbrPtrseg>=0 && node->fils[3]->nbrPtrseg>=0);
  
  x0=node->x0;
  y0=node->y0;
  x1=node->x1;
  y1=node->y1;
  
  node->zone=node->fils[0]->zone;

  // ptrsegs

  //if(dShad) printf("TO (%f,%f)(%f,%f)\n",node->x0,node->y0,node->x1,node->y1);
  
  for(j=0;j<4;j++)
    {
      //if(dShad) printf("FROM (%f,%f)(%f,%f)\n",node->fils[j]->x0,node->fils[j]->y0,node->fils[j]->x1,node->fils[j]->y1);
      ptrseg=node->fils[j]->ptrseg.next;
      while(ptrseg!=NULL)
	{
	  //if(dShad) printf("node_merge: seg (%f,%f)(%f,%f)\n",ptrseg->seg->p[0].x,ptrseg->seg->p[0].y,ptrseg->seg->p[1].x,ptrseg->seg->p[1].y);
	  /*if(dShad) {
	    shadows_ptrseg_t *ptrseg2=ptrseg->seg->ptrseg;
	    while(ptrseg2!=NULL) {
	      printf("(%f,%f)(%f,%f) ",ptrseg2->node->x0,ptrseg2->node->y0,ptrseg2->node->x1,ptrseg2->node->y1);
	      ptrseg2=ptrseg2->aft;
	    }
	    printf("\n");
	    }*/
	  
	  ptrsegtmp=ptrseg->next;
	  if(ptrseg->aft && ((n=ptrseg->aft->node)->x0==x0 || n->x1==x1 ) && ( n->y0==y0 || n->y1==y1 ))
	    {
	      /* efface ptrseg */
	      //if(dShad) printf("node_merge: effacage ptrseg\n");
	      if(ptrseg->bef!=NULL){
		ptrseg->bef->aft=ptrseg->aft;
		//if(dShad) printf("bef!=NULL\n");
	      } else {
		//if(dShad) printf("bef==NULL\n");
		ptrseg->seg->ptrseg=ptrseg->aft;
	      }
	      //assert(ptrseg->aft!=NULL);
	      ptrseg->aft->bef=ptrseg->bef;
	      FREEPTRSEG(s,ptrseg);
	    }
	  else
	    {
	      /* chaine ptrseg */
	      //if(dShad) printf("node_merge: garde ptrseg\n");
	      i++;
	      ptrseg->next=ptrseg2->next;
	      ptrseg->prev=ptrseg2;
	      if(ptrseg2->next)
		ptrseg2->next->prev=ptrseg;
	      ptrseg2->next=ptrseg;
	      ptrseg->node=node;
	    }
	  ptrseg=ptrsegtmp;
	}
    }

  // SPEED
  
  /*for(ptrseg=node->ptrseg.next;ptrseg!=NULL;ptrseg=ptrseg->next) {
    ptrseg->node=node;
  }*/
  

  node->nbrPtrseg=i;
  //node->ptrseg.next=ptrseg2;
  //ptrseg2->prev=&(node->ptrseg);
  
  // points
  
  ppt=&(node->pt);
  ppt->next=ppt->prev=ppt;
  for(j=0;j<4;j++) {
    if(node->fils[j]->pt.next!=&node->fils[j]->pt) {
      node->fils[j]->pt.prev->next=ppt->next;
      node->fils[j]->pt.next->prev=ppt;
      ppt->next->prev=node->fils[j]->pt.prev;
      ppt->next=node->fils[j]->pt.next;
    }
  }

  for(j=0;j<4;j++)
    FREENODE(s,node->fils[j]);
}

static void rec_(shadows_t *s,shadows_node_t *node,int nbrSeg,mask_t maskSeg,mask_t maskPt,info_seg_t tabInfo[],shadows_ptrseg_t *tabPtrseg[][2])
{
  int i,j;
  shadows_ptrseg_t *ptrseg;
  shadows_pt_t *ppt;
  shadows_seg_t *seg;
  svec_t fc;
  mask_t m;

  if(dShad) printf("rec_\n");

  // Recalcul node->zone;
  for(i=0;i<nbrSeg;i++)
    if((maskSeg & (1<<i)) && COTESEGXY2_(tabInfo[i].seg,node->x0,node->y0)<0.) {
      break;
    }
  if(i==nbrSeg)
    node->zone=ADDZONE(node->zone,Zone);
      
  // Chaine segs
  ptrseg=node->ptrseg.next;
  m=(maskSeg<<DECAL_SEGMASK) | SEGMASK_0;
  while(ptrseg!=NULL) {
    if(!(seg=ptrseg->seg)->mask) {
      seg->next=listSeg.next;
      listSeg.next=seg;
    }
    seg->mask|=m;
    /*if(!ptrseg->seg->mask) {
      ptrseg->seg->next=listSeg.next;
      listSeg.next=ptrseg->seg;
    }
    ptrseg->seg->mask|=m;*/
    ptrseg=ptrseg->next;
  }

  // Points
  ppt=node->pt.next;
  while(ppt!=&node->pt) {

    /*for(i=0;i<nbrSeg;i++)
      if(maskPt & (1<<i))
	if(ppt->x==tabInfo[i].x && ppt->y==tabInfo[i].y) {
	  tabInfo[i].pt=ppt;
	  ppt->mask=PTMASK_1;
	  ppt_complet=ppt;
	}*/

    // if(ppt->mask==0) {
      ppt->mask=PTMASK_1;
      ppt->idRet=-1;
      for(i=0;i<nbrSeg;i++)
	if(maskSeg & (1<<i))
	  if((fc=COTESEGXY2_(tabInfo[i].seg,ppt->x,ppt->y))<0.) {
	    ppt->mask=0;
	    break;
	  }
	  else {
	    if(fc==0.) {
	      ppt->mask|=1<<i+DECAL_PTMASK;
#ifdef SHADOWS_RET_3D
	      //ppt->mask2|=1<<i+DECAL_PTMASK2;
#endif
	      if(ppt->x==tabInfo[i].x && ppt->y==tabInfo[i].y) {
		tabInfo[i].pt=ppt;
		//ppt->mask=PTMASK_1;
		ppt_complet=ppt;
	      }
	      else {
		if((j=i+1)==nbrSeg) j=0;
		//j=(i+1)%nbrSeg; 	      
		if(ppt->x==tabInfo[j].x && ppt->y==tabInfo[j].y) {
		  tabInfo[j].pt=ppt;
		  //ppt->mask=PTMASK_1;
		  ppt_complet=ppt;
		}
	      }
	    }
	  }
      if(ppt->mask && ppt_complet != ppt) {
	if(dShad) printf("lala\n");
#ifdef SHADOWS_RET_3D
	//ppt->mask2|=PTMASK2_0;
	ppt->idRet=-1;
#else
	ppt->idRet=nbrRetPt;
	tabRetXY[nbrRetPt][0]=ppt->x;
	tabRetXY[nbrRetPt][1]=ppt->y;
	nbrRetPt++;
#endif
      }
      //}
      ppt=ppt->next;
  }

  // Cree les nouveaux points
  for(i=0;i<nbrSeg;i++)
    if((maskPt & (1<<i)) && tabInfo[i].pt==NULL) {
      NEWPT(s,ppt);
      tabInfo[i].pt=ppt;
      ppt->x=tabInfo[i].x;
      ppt->y=tabInfo[i].y;
      ppt->nbr=0;
      // SPEED ( a virer, on le fait deja plus tard)
      ppt->mask=PTMASK_1;
#ifdef SHADOWS_RET_3D
      // SPEED ( a virer, on le fait deja plus tard)
      ppt->mask2=0;
#endif
      ppt->next=node->pt.next;
      ppt->prev=&node->pt;
      node->pt.next->prev=ppt;
      node->pt.next=ppt;
    }
      
  // Trouve le meilleur node pour checkpoint
  // SPEED ( autre chose que les points ...)
  if(maskPt)
    if(minNbrSegCheck==-1 || minNbrSegCheck > node->nbrPtrseg) {
      minNbrSegCheck=node->nbrPtrseg;
      minNodeCheck=node;
      minZoneCheck=node->zone;
      for(i=0;i<nbrSeg;i++)
	if(maskPt & (1<<i)) {
	  minPtCheck=tabInfo[i].pt;
	  break;
	}
    }

  // Cree ptrseg
  for(i=0;i<nbrSeg;i++) {
    if(maskSeg & (1<<i)) {
      NEWPTRSEG(s,ptrseg);
      ptrseg->node=node;
      // SPEED ?
      ptrseg->seg=NULL;
      node->nbrPtrseg++;
      ptrseg->next=node->ptrseg.next;
      ptrseg->prev=&node->ptrseg;
      if(node->ptrseg.next)
	node->ptrseg.next->prev=ptrseg;
      node->ptrseg.next=ptrseg;
      tabPtrseg[i][0]=tabPtrseg[i][1]=ptrseg;

      // SPEED SPEED SPEED
      //ptrseg->aft=ptrseg->bef=NULL;
    }
  }
}

static void rec(shadows_t *s,shadows_node_t *node,int nbrSeg,mask_t maskSeg,mask_t maskPt,info_seg_t tabInfo[],shadows_ptrseg_t *tabPtrseg[][2],svec_t minx,svec_t miny,svec_t maxx,svec_t maxy)
{
  int i,i_;
  
  if(node->nbrPtrseg>=0)
    {
      /* teste si on coupe le node */
      if (node->nbrPtrseg >= NODE_CUT_LIM) {
	//if(dShad) printf("node_cut\n");
	node_cut(s,node);
	//verInt2(&s->node);
      }
    }
  else
    {
      if((i=node->fils[0]->nbrPtrseg)>=0 && (i_=node->fils[1]->nbrPtrseg)>=0 && 
	 ((i+=i_),(i_=node->fils[2]->nbrPtrseg)>=0) && ((i+=i_),(i_=node->fils[3]->nbrPtrseg)>=0) && (i+i_)<NODE_MERGE_LIM ) {
	//if(dShad) printf("node_merge\n");
	node_merge(s,node);
	//verInt2(&s->node);
      }
    }

  if(node->nbrPtrseg>=0)
    {
      rec_(s,node,nbrSeg,maskSeg,maskPt,tabInfo,tabPtrseg);
    }
  else {
    svec_t x,y;
    
    x=node->fils[0]->x1;
    y=node->fils[0]->y1;
    
    if(maxx<x) { 
      if(maxy<y) 
	{ rec(s,node->fils[0],nbrSeg,maskSeg,maskPt,tabInfo,tabPtrseg,minx,miny,maxx,maxy); return;}
      else if(miny>=y)
	{ rec(s,node->fils[2],nbrSeg,maskSeg,maskPt,tabInfo,tabPtrseg,minx,miny,maxx,maxy); return;}
    }
    else if(minx>=x) {
      if(maxy<y) 
	{ rec(s,node->fils[1],nbrSeg,maskSeg,maskPt,tabInfo,tabPtrseg,minx,miny,maxx,maxy);return;}
      else if(miny>=y)
	{ rec(s,node->fils[3],nbrSeg,maskSeg,maskPt,tabInfo,tabPtrseg,minx,miny,maxx,maxy);return;}
    }
    {
      int j;
      svec_t x0,x1,y0,y1;
      svec_t x_,y_,x0_,x1_,y0_,y1_;
      shadows_ptrseg_t *tabPtrseg2[4][nbrSeg][2],*ptrseg,*ptrseg2;
      //shadows_ptrseg_t *tabPtrseg2[4][MAX_NSEG][2],*ptrseg,*ptrseg2;
      mask_t mS[4]={0,0,0,0},mP[4]={0,0,0,0},m;
      char l[4]={1,1,1,1};
      char chPtrseg[nbrSeg][4];
      //int chPtrseg[MAX_NSEG][4];
      shadows_seg_t *seg;
      char k,km;
      
      svec_t dm,d;
      //svec_t a,b;
      svec_t dx,dy;
      
      if(dShad) printf("rec\n");
      
      x0=node->x0;
      y0=node->y0;
      x1=node->x1;
      y1=node->y1;
      
      for(i=0;i<nbrSeg;i++) {
	// Points
	if(maskPt & (1<<i)) {
	  j=0;
	  if(tabInfo[i].x >= x) j++;
	  if(tabInfo[i].y >= y) j+=2;
	  mP[j]|=1<<i;
	}
      }
      
      // SPEED ? (enlever la boucle ???)
      for(i=0;i<nbrSeg;i++) {
	// Segs
	if(maskSeg & (1<<i)) {
	  stat_rec[0]++;
	  m=0;
	  j=0;
	  seg=tabInfo[i].seg;
	  
	  dx=seg->xo1-seg->xo0;
	  dy=seg->yo1-seg->yo0;
	  x_=(x-seg->xo0)*dy;
	  x0_=(x0-seg->xo0)*dy;
	  x1_=(x1-seg->xo0)*dy;
	  y_=(y-seg->yo0)*dx;
	  y0_=(y0-seg->yo0)*dx;
	  y1_=(y1-seg->yo0)*dx;
	  
	  if(seg->sens==1) {
	    if(y0_<=x0_) m|=1;
	    if(y0_<=x_) m|=2;
	    if(y0_<=x1_) m|=4;
	    if(y_<=x0_) m|=8;
	    if(y_<=x_) m|=16;
	    if(y_<=x1_) m|=32;
	    if(y1_<=x0_) m|=64;
	    if(y1_<=x_) m|=128;
	    if(y1_<=x1_) m|=256;
	  } else {
	    if(y0_>x0_) m|=1;
	    if(y0_>x_) m|=2;
	    if(y0_>x1_) m|=4;
	    if(y_>x0_) m|=8;
	    if(y_>x_) m|=16;
	    if(y_>x1_) m|=32;
	    if(y1_>x0_) m|=64;
	    if(y1_>x_) m|=128;
	    if(y1_>x1_) m|=256;
	  }
	  /*
	    if(COTESEGXY(seg,x0,y0)<0.) m|=1;
	    if(COTESEGXY(seg,x,y0)<0.) m|=2;
	    if(COTESEGXY(seg,x1,y0)<0.) m|=4;
	    if(COTESEGXY(seg,x0,y)<0.) m|=8;
	    if(COTESEGXY(seg,x,y)<0.) m|=16;
	    if(COTESEGXY(seg,x1,y)<0.) m|=32;
	    if(COTESEGXY(seg,x0,y1)<0.) m|=64;
	    if(COTESEGXY(seg,x,y1)<0.) m|=128;
	    if(COTESEGXY(seg,x1,y1)<0.) m|=256;
	  */
	  
	  if ((m & M0) && ((m & M0) != M0) &&
	      (seg->p[0].x < x || seg->p[1].x < x) &&
	      (seg->p[0].y < y || seg->p[1].y < y))  { 
	    j++;k=0;
	    mS[0]|=1<<i;
	  }
	  else if(!(m & 0x1)) l[0]=0;

	  if ((m & M1) && ((m & M1) != M1) &&
	      (seg->p[0].x >= x || seg->p[1].x >= x) &&
	      (seg->p[0].y < y || seg->p[1].y < y))  { 
	    j++;k=1;
	    mS[1]|=1<<i;
	  }
	  else if(!(m & 0x2)) l[1]=0;
    
	  if ((m & M2) && ((m & M2) != M2) &&
	      (seg->p[0].x < x || seg->p[1].x < x) &&
	      (seg->p[0].y >= y || seg->p[1].y >= y))  { 
	    j++;k=2;
	    mS[2]|=1<<i;
	  }
	  else if(!(m & 0x8)) l[2]=0;

	  if ((m & M3) && ((m & M3) != M3) &&
	      (seg->p[0].x >= x || seg->p[1].x >= x) &&
	      (seg->p[0].y >= y || seg->p[1].y >= y))  { 
	    j++;k=3;
	    mS[3]|=1<<i;
	  }
	  else if(!(m & 0x10)) l[3]=0;
	  
	  if(j<1 || j>3) printf("j=%d m=0x%X seg=(%f,%f)(%f,%f)\n",j,m,seg->p[0].x,seg->p[0].y,seg->p[1].x,seg->p[1].y);
	  assert(j>=1 && j<=3);

	  if(j==1) {
	    stat_rec[1]++;

	    chPtrseg[i][0]=k;
	    chPtrseg[i][1]=4;
	  } else {

	    km=-1;
	    for(k=0;k<4;k++) {
	      if(mS[k]&(1<<i)) {
		d=(seg->p[1].x-seg->p[0].x)*(node->fils[k]->x0-seg->p[0].x)+
		  (seg->p[1].y-seg->p[0].y)*(node->fils[k]->y0-seg->p[0].y);
		if(km==-1 || d<dm) {
		  km=k;
		  dm=d;
		}
	      }
	    }

	    assert(km!=-1);
	    chPtrseg[i][0]=km;
	    
	    m=1;
	    k=km ^ m;
	    if(!(mS[k]&(1<<i))) {
	      m^=3;
	      k=km ^ m;
	    }	
	    
	    assert(mS[k]&(1<<i));
	    chPtrseg[i][1]=k;
	    
	    m^=3;
	    km=k^m;
	    
	    assert((j==3 && (mS[km]&(1<<i))) || (j==2 && !(mS[km]&(1<<i)))); 
	    if(mS[km]&(1<<i)) {
	      chPtrseg[i][2]=km;
	      chPtrseg[i][3]=4;
	    } else 	    
	      chPtrseg[i][2]=4;
	  }
	}
      }

      // Appels recursifs
      for(i=0;i<4;i++) {
	if(mP[i])
	  assert(mS[i]);
	if(mS[i] || l[i])
	  rec(s,node->fils[i],nbrSeg,mS[i],mP[i],tabInfo,tabPtrseg2[i],minx,miny,maxx,maxy);
      }
      
      // Rechainer ptrseg
      for(i=0;i<nbrSeg;i++)
	if(maskSeg & (1<<i)) {
	  tabPtrseg[i][0]=tabPtrseg2[chPtrseg[i][0]][i][0];
	  for(j=0;chPtrseg[i][j+1]!=4;j++) {
	    (ptrseg=tabPtrseg2[chPtrseg[i][j]][i][1])->aft=ptrseg2=tabPtrseg2[chPtrseg[i][j+1]][i][0];
	    ptrseg2->bef=ptrseg;
	  }
	  tabPtrseg[i][1]=tabPtrseg2[chPtrseg[i][j]][i][1];
	}
    }
  }
}

#undef M0
#undef M1
#undef M2
#undef M3
