/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "shadows.h"
#include "utils.h"

int tototo=0;

/*
  FIX : 
  - simplify
  - enlever return 0...

  SPEED: 
  - inline
  - passer test xj->concave de isanear dans triangulate
*/

#define COTEPTPTPT_(pt1,pt2,pt) (((pt2)->x-(pt1)->x)*((pt)->y-(pt1)->y)-((pt2)->y-(pt1)->y)*((pt)->x-(pt1)->x))

//INLINE
static void simplify(shadows_poly_t tabRet[],int *nbrRetPoly,/*svec_t tabRetXY[][2],int nbrRetPt,*/int nbrRetHole)
{
  printf("HOLE!\n");
  //assert(0);
}

//INLINE
static int isAnEar(shadows_seg_2_t *xj)
{
  shadows_seg_2_t *seg_2=xj->nextP->nextP;
  
  // SPEED 
  if(xj->concave) return 0;
  while (seg_2!=xj->prevP) {
    if(seg_2->concave) {
      if((COTEPTPTPT_(xj->prevP,xj,seg_2)<=0.) &&
	 (COTEPTPTPT_(xj,xj->nextP,seg_2)<=0.) &&
	 (COTEPTPTPT_(xj->nextP,xj->prevP,seg_2)<=0.)) return 0;
    }
    seg_2=seg_2->nextP;
  }
  return 1;
}

int shadows_triangulate(shadows_poly_t tabRet[],int nbrRetPoly,/*svec_t tabRetXY[][2],int nbrRetPt,*/int nbrRetHole,shadows_ret_t tabRetPoly[],int tabRetId[])
{
  int i,j,Id=0;
  shadows_seg_2_t *seg_2,*xi;//,*xt;
  int poly=0,concave;

  if(nbrRetHole) {
    simplify(tabRet,&nbrRetPoly,/*tabRetXY,nbrRetPt,*/nbrRetHole);
    return 0;
  }
  for(i=0;i<nbrRetPoly;i++) {
    
    //FIX
    if(tabRet[i].hole==0) {
      /* triangulation */
      concave=tabRet[i].concave;
      xi=tabRet[i].seg_2->nextP->nextP;
      if(tototo!=2)
      while(xi!=tabRet[i].seg_2
#ifndef SHADOWS_TRIANGULATE
	    && concave>0
#endif
	    ) {
	//if(xi->prevP->concave && isAnEar(xi->prevP)) {
	if(isAnEar(xi->prevP)) {
	  
	  tabRetPoly[poly].zone=tabRet[i].zone;
	  tabRetPoly[poly].start=Id;
	  tabRetPoly[poly].nbr=3;
	  tabRetId[Id++]=xi->prevP->prevP->pt->idRet;
	  tabRetId[Id++]=xi->prevP->pt->idRet;
	  tabRetId[Id++]=xi->pt->idRet;
	  poly++;
	  assert(poly<200);
	  assert(Id<700);
	  
	  //xt=xi->prevP;
	  xi->prevP->prevP->nextP=xi;
	  xi->prevP=xi->prevP->prevP;
	  
	  //if(xi->concave && (COTEPTPTPT_(xi->prevP,xi,xi->nextP)*COTEPTPTPT_(xt,xi,xi->nextP))<=0.) {
	  if(xi->concave && COTEPTPTPT_(xi->prevP,xi,xi->nextP)<=0.) {
	    concave--;
	    xi->concave=0;
	  }
	  //if(xi->prevP->concave && (COTEPTPTPT_(xi->prevP,xi,xi->prevP->prevP)*COTEPTPTPT_(xi->prevP,xt,xi->prevP->prevP))<=0.) {
	  if(xi->prevP->concave && COTEPTPTPT_(xi->prevP,xi,xi->prevP->prevP)<=0.) {
	    concave--;
	    xi->prevP->concave=0;
	  }
	  if(xi->prevP==tabRet[i].seg_2)
	    xi=xi->nextP;
	  
	}
	else xi=xi->nextP;
	
	assert(concave>=0);
      }
      
#ifndef SHADOWS_TRIANGULATE
      tabRetPoly[poly].zone=tabRet[i].zone;
      tabRetPoly[poly].start=Id;
      j=0;
      seg_2=tabRet[i].seg_2;
      do {
	tabRetId[Id]=seg_2->pt->idRet;
	Id++;j++;
	seg_2=seg_2->nextP;
      } while(seg_2!=tabRet[i].seg_2);
      tabRetPoly[poly].nbr=j;
      poly++;
      assert(poly<200);
      assert(Id<700);
#endif
    } 
  }
  
  //if(poly>20) printf("poly=%d\n",poly);
  
  return poly;
}
