/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysymdef.h>
#include <time.h>
#include "shadows.h"
#include "utils.h"
#include "ase.h"
#include "tr.h"

double minx=-0.7;
double miny=-0.7;
double maxx=0.7;
double maxy=0.7;
double mm=0.7,x=0.,y=0.;

/*
#define minx -0.7
#define miny -0.7
#define maxx 0.7
#define maxy 0.7

#define minx 0.25
#define miny -0.25
#define maxx 0.5
#define maxy 0.
*/
#define sizex 900
#define sizey 900

#define D 1.

Display *Serveur;
int Ecran;
Window Racine;
Window Win; 
GC gc,gc2,gcb;
XSizeHints x_sh;
Font font;

typedef struct {
  int n;
  float z;
} poly_z_t;

poly_z_t *poly_z;

shadows_t* shad;

shadows_pt_t *pptm=NULL;
shadows_seg_t *psegm=NULL;
shadows_node_t *NODE;
int NODEP=0;
char cotem=0;
int r=0;
zone_t zm=NOZONE;
svec_t zx=0.,zy=0.;
svec_t nodex=0.,nodey=0.;
int lalala=0;

extern int dShad;
extern int NODE_CUT_LIM,NODE_MERGE_LIM;

int ConnectionServeur(void)
{
  if((Serveur=XOpenDisplay(NULL))==NULL)
    {
      printf("Impossible de se connecter au serveur %s\n",XDisplayName(NULL));
      return(0);
    }
  Ecran=DefaultScreen(Serveur);
  Racine=RootWindow(Serveur,Ecran);
  return(1);
}

void DeconnectionServeur(void)
{
  if(font!=BadMatch)
    XUnloadFont(Serveur,font);
  XCloseDisplay(Serveur);
}

void CreeWin(void)
{
  char *name="Shadows Test";
  XGCValues xgcv;
  
  x_sh.min_width=x_sh.max_width=x_sh.base_width=sizex;
  x_sh.min_height=x_sh.max_height=x_sh.base_height=sizey;
  x_sh.flags=PMinSize|PMaxSize|PBaseSize;
  Win=XCreateSimpleWindow(Serveur,Racine,0,0,x_sh.base_width,x_sh.base_height,2,WhitePixel(Serveur,Ecran),BlackPixel(Serveur,Ecran));
  XSelectInput(Serveur,Win,ExposureMask|ButtonPressMask|KeyPressMask); 
  XStoreName(Serveur,Win,name);
  XSetStandardProperties(Serveur,Win,name,"shadows",None,NULL,0,&x_sh);
  gc=DefaultGC(Serveur,Ecran);
  XSetForeground(Serveur,gc,WhitePixel(Serveur,Ecran));

  /*FIX*/
  gc2=XCreateGC(Serveur,Win,0,&xgcv);
  xgcv.foreground=WhitePixel(Serveur,Ecran);
  XChangeGC(Serveur,gc2,GCForeground,&xgcv);
  gcb=XCreateGC(Serveur,Win,0,&xgcv);
  xgcv.line_style=LineOnOffDash;
  XChangeGC(Serveur,gcb,GCLineStyle,&xgcv);

  if((font=XLoadFont(Serveur,"fixed"))==BadName)
    printf("Erreur Lors du chargement de la police \"fixed\"\n");
  else
    XSetFont(Serveur,gc,font);
  
  XMapWindow(Serveur,Win);
}


#define ttt(x,y) (x>-2000 && x<2000 && y>-2000 && y <2000)

void line(GC gc,float x1,float y1,float x2,float y2)
{
  float a_,b_,c_,d_,l;
  x1=(x1-minx)*sizex/(maxx-minx);
  x2=(x2-minx)*sizex/(maxx-minx);
  y1=(y1-miny)*sizey/(maxy-miny);
  y2=(y2-miny)*sizey/(maxy-miny); 
  a_=x2-x1;
  b_=y2-y1;
  l=sqrt(a_*a_+b_*b_);
  c_=1000*a_/l;
  d_=1000*b_/l;
  if(ttt(x1,y1) && ttt(x2,y2))
    XDrawLine(Serveur,Win,gc,x1,y1,x2,y2);
  else {
    if(x1>-2000 && x1<2000 && y1>-2000 && y1 < 2000)
      XDrawLine(Serveur,Win,gc,x1,y1,x1+c_,y1+d_);
    if(x2>-2000 && x2<2000 && y2>-2000 && y2 < 2000)
      XDrawLine(Serveur,Win,gc,x2-c_,y2-d_,x2,y2);
  }
}

void rectangle(GC gc,float x1,float y1,float x2,float y2)
{
  float a,b,c,d;
  a=(x1-minx)*sizex/(maxx-minx);
  b=(x2-minx)*sizex/(maxx-minx);
  c=(y1-miny)*sizey/(maxy-miny);
  d=(y2-miny)*sizey/(maxy-miny); 
  if(ttt(a,c) && ttt(b,d))
  {
    int a,b,c,d;
    a=(x1-minx)*sizex/(maxx-minx);
    b=(x2-minx)*sizex/(maxx-minx);
    c=(y1-miny)*sizey/(maxy-miny);
    d=(y2-miny)*sizey/(maxy-miny);
    XDrawRectangle(Serveur,Win,gc,a,c,b-a,d-c);
  }
}

void point(GC gc,int a,float x,float y)
{
  char tmp[10];
  sprintf(tmp,"%d",a);
  x=(x-minx)/(maxx-minx)*sizex;
  y=(y-miny)/(maxy-miny)*sizey;
  XDrawString(Serveur,Win,gc,x-3,y+5,tmp,strlen(tmp));
  //XFillArc(Serveur,Win,gc,x-5,y-5,10,10,0*64,360*64);
  //XDrawLine(Serveur,Win,gc,x1,y1,x2,y2);
}

void point2(GC gc,int a,float x,float y)
{
  char tmp[10];
  sprintf(tmp,"%d",a);
  x=(x-minx)/(maxx-minx)*sizex;
  y=(y-miny)/(maxy-miny)*sizey;
  //XDrawString(Serveur,Win,gc,x-3,y+5,tmp,strlen(tmp));
  XDrawArc(Serveur,Win,gc,x-7,y-7,14,14,0*64,360*64);
  //XDrawLine(Serveur,Win,gc,x1,y1,x2,y2);
}

void point3(GC gc,int a,float x,float y)
{
  char tmp[10];
  sprintf(tmp,"%d",a);
  x=(x-minx)/(maxx-minx)*sizex;
  y=(y-miny)/(maxy-miny)*sizey;
  //XDrawString(Serveur,Win,gc,x-3,y+5,tmp,strlen(tmp));
  XDrawRectangle(Serveur,Win,gc,x-4,y-4,8,8);
  //XDrawLine(Serveur,Win,gc,x1,y1,x2,y2);
}

void point4(GC gc,char a,float x,float y)
{
  char tmp[10];
  sprintf(tmp,"%c",a);
  x=(x-minx)/(maxx-minx)*sizex;
  y=(y-miny)/(maxy-miny)*sizey;
  XDrawString(Serveur,Win,gc,x,y,tmp,strlen(tmp));
  //XDrawRectangle(Serveur,Win,gc,x-4,y-4,8,8);
  //XDrawLine(Serveur,Win,gc,x1,y1,x2,y2);
}

void find_pt(shadows_t *s,float x,float y) 
{
  int i;
  shadows_pt_t *ppt;
  double dmin;

  pptm=NULL;
  
  for(i=0;i<s->sizeTabPt;i++)
    s->tabPt[i].mask|=1<<15;
  ppt=s->freePt;
  while(ppt!=NULL) {
    ppt->mask&=~(1<<15);
    ppt=ppt->next;  }
  
  for(i=0;i<s->sizeTabPt;i++) {
    ppt=&s->tabPt[i];
    if(ppt->mask & (1<<15)) {
      if(pptm==NULL || sqrt((ppt->x-x)*(ppt->x-x)+(ppt->y-y)*(ppt->y-y)) < dmin) {
	pptm=ppt;
	dmin=sqrt((pptm->x-x)*(pptm->x-x)+(pptm->y-y)*(pptm->y-y));
      }
    }
    s->tabPt[i].mask&=~(1<<15);
  }
}

void find_seg(shadows_t *s,float x,float y) 
{
  int i;
  shadows_seg_t *pseg;
  double dmin;

  psegm=NULL;
  
  for(i=0;i<s->sizeTabSeg;i++)
    s->tabSeg[i].mask|=1<<15;
  pseg=s->freeSeg;
  while(pseg!=NULL) {
    pseg->mask&=~1<<15;
    pseg=pseg->next;  }
  
  for(i=0;i<s->sizeTabSeg;i++) {
    pseg=&s->tabSeg[i];
    if(pseg->mask & (1<<15)) {
      if(psegm==NULL || sqrt(((pseg->p[0].x+pseg->p[1].x)*0.5-x)*((pseg->p[0].x+pseg->p[1].x)*0.5-x)+((pseg->p[0].y+pseg->p[1].y)*0.5-y)*((pseg->p[0].y+pseg->p[1].y)*0.5-y)) < dmin) {
	psegm=pseg;
	dmin=sqrt(((pseg->p[0].x+pseg->p[1].x)*0.5-x)*((pseg->p[0].x+pseg->p[1].x)*0.5-x)+((pseg->p[0].y+pseg->p[1].y)*0.5-y)*((pseg->p[0].y+pseg->p[1].y)*0.5-y));
      }
    }
    s->tabSeg[i].mask&=~(1<<15);
  }
}
  
  
/* affiche une ombre */
void aff_shadow(shadows_t* s,shadows_node_t *node)
{
  int i;
  static int nbrpt,nbrseg,nbrptrseg;
  char tmp[100],tmp2[1000],cote,ctmp;
  shadows_seg_t *pseg;
  shadows_pt_t *ppt;
  shadows_ptrseg_t *ptrseg;

  if(node==NODE) {
    nbrpt=nbrseg=nbrptrseg=0;
  }
  if(node->nbrPtrseg<0) {
    for(i=0;i<4;i++) {
      aff_shadow(s,node->fils[i]);
    }
  }
  else {
    
  rectangle(gc,node->x0,node->y0,node->x1,node->y1);
  
  if (psegm) {
    point3(gc,0,0.5*(psegm->p[0].x+psegm->p[1].x),0.5*(psegm->p[0].y+psegm->p[1].y));
    sprintf(tmp2,"seg: (%f,%f) %f %d |  (%f,%f) %f %d | cote= %d",psegm->p[0].x,psegm->p[0].y,psegm->p[0].tet,psegm->p[0].zone,psegm->p[1].x,psegm->p[1].y,psegm->p[1].tet,psegm->p[1].zone,cotem);
    XDrawString(Serveur,Win,gc,0,40,tmp2,strlen(tmp2));
  }
  
  ptrseg=node->ptrseg.next;
  while(ptrseg!=NULL) {
    shadows_seg_t *seg=ptrseg->seg;
    nbrptrseg++;
    if(seg) {
      if(lalala) if( ptrseg->bef==NULL && seg->ptrseg!=ptrseg) printf("erreur ptrseg->seg->ptrseg != ptrseg\n");
      if(lalala) if( ptrseg->node!=node) printf("erreur ptrseg->node != node\n");
      if(lalala) if( ptrseg->aft && ptrseg->aft->node==node) printf("erreur ptrseg->aft->node == node\n");
      if(lalala) if( ptrseg->bef && ptrseg->bef->node==node) printf("erreur ptrseg->bef->node == node\n");
      if(lalala) if( ptrseg->bef && ptrseg->bef->aft!=ptrseg) {
	printf("erreur ptrseg->bef->aft != ptrseg\n");
	printf("node=(%f,%f)(%f,%f)  seg=(%f,%f)(%f,%f)\n",ptrseg->node->x0,ptrseg->node->y0,ptrseg->node->x1,ptrseg->node->y1,
	       seg->p[0].x,seg->p[0].y,seg->p[1].x,seg->p[1].y);
      }
      if(lalala) if( ptrseg->aft && ptrseg->aft->bef!=ptrseg) {
	printf("erreur ptrseg->aft->bef != ptrseg\n");
	printf("node=(%f,%f)(%f,%f)  seg=(%f,%f)(%f,%f)\n",ptrseg->node->x0,ptrseg->node->y0,ptrseg->node->x1,ptrseg->node->y1,
	       seg->p[0].x,seg->p[0].y,seg->p[1].x,seg->p[1].y);
      }
      if(lalala) if( seg->p[0].pt->x != seg->p[0].x || seg->p[0].pt->y != seg->p[0].y ||
		     seg->p[1].pt->x != seg->p[1].x || seg->p[1].pt->y != seg->p[1].y) 
	printf("erreur 1 (%f,%f)(%f,%f) (%f,%f)(%f,%f)\n",seg->p[0].pt->x,seg->p[0].pt->y,seg->p[0].x,seg->p[0].y,seg->p[1].pt->x,seg->p[1].pt->y,seg->p[1].x,seg->p[1].y);
      if(lalala) if( seg->p[0].zone == seg->p[1].zone)
	printf("Erreur zones ==\n");
      line(gc,seg->p[0].x,seg->p[0].y,
	 seg->p[1].x,seg->p[1].y);
    }
    ptrseg=ptrseg->next;
  }

  //if(lalala && nbrseg!=node->nbrPtrseg) 
  //  printf("Erreur nbrPtrseg trouve=%d node->nbrPtrseg=%d\n",nbrseg,node->nbrPtrseg);

  if (pptm) {
    point2(gc,0,pptm->x,pptm->y);
    sprintf(tmp2,"pt: (%f,%f) %d: ",pptm->x,pptm->y,pptm->nbr);
    pseg=pptm->seg;cote=pptm->cote;
    for(i=0;i<pptm->nbr;i++) {
      sprintf(tmp,"%f ",pseg->p[cote].tet);
      strcat(tmp2,tmp);
      ctmp=pseg->p[cote].nextCote;
      pseg=pseg->p[cote].next;
      cote=ctmp;
    }
    if(pseg!=pptm->seg || cote!=pptm->cote) strcat(tmp2,"ERROR ");
    XDrawString(Serveur,Win,gc,0,30,tmp2,strlen(tmp2));
  }
  
  ppt=node->pt.next;
  while(ppt!=&node->pt) {
    nbrpt++;
    if(lalala && ppt->nbr<=1) printf("erreur pt->nbr<=1\n");
    point(gc,ppt->nbr,ppt->x,ppt->y);
    
    ppt=ppt->next;
  }
  
  }
  
  if(node==NODE) {
  sprintf(tmp,"r:%d pt:%d ptrseg:%d",r,nbrpt,nbrptrseg);
  XDrawString(Serveur,Win,gc,0,10,tmp,strlen(tmp));
  
  sprintf(tmp,"(%f,%f)",x,y);
  XDrawString(Serveur,Win,gc,0,20,tmp,strlen(tmp));

  sprintf(tmp,"zone: (%f,%f) %d",zx,zy,zm);
  XDrawString(Serveur,Win,gc,0,50,tmp,strlen(tmp));
  point4(gc,'Z',zx,zy);
  
  //lalala=0;
  XFlush(Serveur);
  }
}

void aff(shadows_t *s)
{
  XClearWindow(Serveur,Win);
  {
    int k=NODEP,l;
    NODE=&s->node;
    while(NODE->nbrPtrseg<0 && k) {
      l=0;
      if(nodex>=NODE->fils[0]->x1) l++;
      if(nodey>=NODE->fils[0]->y1) l+=2;
      NODE=NODE->fils[l];
      k--;
    }
  }
  aff_shadow(shad,NODE);
}

void Evenement(void)
{
  double xt,yt;
  XEvent E;
  int fin=0;

  while(!fin)
    {
      //switch(XCheckMaskEvent(Serveur,ExposureMask,&E))
      XNextEvent(Serveur,&E);
      //printf("Event %d\n",E.type);
      switch(E.type)
	{
	case Expose:
	case GraphicsExpose:
	  aff(shad);
	  break;
	case KeyPress:
	  if(E.xkey.type==KeyPress) {
	    //printf("%d \n",E.xkey.keycode);
	    switch(E.xkey.keycode) {
	    case 32: 
	      pptm=NULL;psegm=NULL;
	      aff(shad);
	      break;
	    case 36: 
	      fin=1;
	      break;
	    case 33: 
	      xt=minx+(float)E.xkey.x/sizex*(maxx-minx);
	      yt=miny+(float)E.xkey.y/sizey*(maxy-miny);
	      find_pt(shad,xt,yt);
	      aff(shad);
	      break;
	    case 39: 
	      xt=minx+(float)E.xkey.x/sizex*(maxx-minx);
	      yt=miny+(float)E.xkey.y/sizey*(maxy-miny);
	      find_seg(shad,xt,yt);
	      aff(shad);
	      break;
	    case 41:
	      if(pptm==NULL) break;
	      psegm=pptm->seg;
	      cotem=pptm->cote;
	      aff(shad);
	      break;
	    case 25: // Z
	      zx=minx+(float)E.xkey.x/sizex*(maxx-minx);
	      zy=miny+(float)E.xkey.y/sizey*(maxy-miny);
	      zm=shadows_checkPoint(shad,zx,zy);
	      aff(shad);
	      break;
	    case 27: 
	      if(psegm==NULL) break;
	      {
		char ctmp=psegm->p[cotem].nextCote;
		psegm=psegm->p[cotem].next;
		cotem=ctmp;
		aff(shad);
	      }
	      break;
	    case 28: cotem=1-cotem;
	      aff(shad);
	      break;
	    case 29:
	      if(psegm==NULL) break;
	      {
		char ctmp=psegm->p[cotem].nextCote;
		psegm=psegm->p[cotem].next;
		cotem=1-ctmp;
		aff(shad);
	      }
	      break;
	    case 42:
	      if(psegm==NULL) break;
	      pptm=psegm->p[cotem].pt;
	      aff(shad);
	      break;
	    case 43:
	      if(psegm==NULL) break;
	      {
		char ctmp=psegm->p[cotem].nextCote;
		psegm=psegm->p[cotem].next;
		cotem=1-ctmp;
		pptm=psegm->p[1].pt;
		aff(shad);
	      }
	      break;
	    case 54:
	      NODE=&shad->node;
	      NODEP=0;
	      aff(shad);
	      break;
	    case 55:
	      if(NODEP)
		NODEP--;
	      aff(shad);
	      break;
	    case 56:
	      NODEP++;
	      aff(shad);
	      break;
	    case 57:
	      //NODEP++;
	      nodex=minx+(float)E.xkey.x/sizex*(maxx-minx);
	      nodey=miny+(float)E.xkey.y/sizey*(maxy-miny);
	      aff(shad);
	      break;
	    }
	  }
	  break;
	case ButtonPress: 
	  if(E.xbutton.type==ButtonPress) {
	    //printf("%d %d\n",E.xbutton.x,E.xbutton.y);
	    //printf("%X\n",E.xbutton.button);
	    switch(E.xbutton.button) {
	    case 3: fin=1;
	      break;
	    case 1:
	      x=minx+(float)E.xbutton.x/sizex*(maxx-minx);
	      y=miny+(float)E.xbutton.y/sizey*(maxy-miny);
	      //printf("%f %f\n",x,y);
	      break;
	    case 4:mm/=1.2;
	      break;
	    case 5:mm*=1.2;
	      break;
	    }
	    if(!fin) {
	      minx=x-mm;
	      miny=y-mm;
	      maxx=x+mm;
	      maxy=y+mm;
	      aff(shad);
	    }
	    break;
	  }
	}
    }
}

void XX(shadows_t *s) {
  aff(s);Evenement();
}

void MUL_MAT(float mat[4][4],float mat2[4][4]) {
  int i,j,k;
  float mat3[4][4];
  for(i=0;i<4;i++)
    for(j=0;j<4;j++){
      mat3[i][j]=0.;
      for(k=0;k<4;k++)
	mat3[i][j]+=mat2[i][k]*mat[k][j];
    }
  for(i=0;i<4;i++)
    for(j=0;j<4;j++)
      mat[i][j]=mat3[i][j];
}

int comp_poly_z(const void *e1,const void *e2)
{
  if (((const poly_z_t*)e1)->z > ((const poly_z_t*)e2)->z) return 1;
  else if (((const poly_z_t*)e1)->z == ((const poly_z_t*)e2)->z) return 0;
  else return -1;
}

typedef float v_2[2];
int main(int argc,char **argv)
{
  float poly[10][2],poly2[10][2],poly3[10][2];
  float a,a2,a3;
  float c=0.17,d=0.15;
  int n=4,i,j,k;
  int r2=0;
  float mat[4][4],mat2[4][4];
  aseobj obj;
  v_2 *v2;
  v_3 *v3;
  long long int totime,otime;
  float tmin[3],tmax[3],md;

  /*if(argc!=4) {
    printf("3 args\n");
    exit(1);
    }*/
  
  if(argc>=3)
    NODE_CUT_LIM=atoi(argv[2]);
  if(argc>=4)
    NODE_MERGE_LIM=atoi(argv[3]);
  
  if(argc==1)
    ase_load("/root/ase/tk.ase",&obj);
  else
    ase_load(argv[1],&obj);
  printf("%d %d\n",obj.numVertex,obj.numFaces);
  v2=(v_2*)malloc(obj.numVertex*sizeof(v_2));
  v3=(v_3*)malloc(obj.numVertex*sizeof(v_3));
  poly_z=(poly_z_t*)malloc(obj.numFaces*sizeof(poly_z_t));
  //for(i=0;i<obj.numVertex;i++)
  //  printf("%f %f %f\n",obj.vertex[i][0],obj.vertex[i][1],obj.vertex[i][2]);
  tmin[0]=tmax[0]=obj.vertex[0][0];
  tmin[1]=tmax[1]=obj.vertex[0][1];
  tmin[2]=tmax[2]=obj.vertex[0][2];
  for(i=1;i<obj.numVertex;i++) {
    for(j=0;j<3;j++) {
      tmin[j]=min(tmin[j],obj.vertex[i][j]);
      tmax[j]=max(tmax[j],obj.vertex[i][j]);
    }
  }
  for(j=0;j<3;j++) {
    float t;
    t=tmax[j];
    tmax[j]-=tmin[j];
    tmin[j]=(tmin[j]+t)/2.;
  }  
  md=max(max(tmax[0],tmax[1]),tmax[2]);

  for(i=0;i<obj.numVertex;i++) 
    for(j=0;j<3;j++) {
      obj.vertex[i][j]-=tmin[j];
      obj.vertex[i][j]*=1./md;
    }

  poly[0][0]=0.;poly[0][1]=0.;
  poly[1][0]=0.;poly[1][1]=c;
  poly[2][0]=c;poly[2][1]=c;
  poly[3][0]=c;poly[3][1]=0.;

#ifndef BENCH
  if(!ConnectionServeur()) exit(1);
  CreeWin();
#endif
  printf("Creation\n");
  shad=shadows_create(NOZONE,0);

  NODE=&shad->node;

  a=0.;a2=0.;a3=0.;
  //RCH=0;
  //  for(NODE_CUT_LIM=10;NODE_CUT_LIM<40;NODE_CUT_LIM+=2)
  //  for(NODE_MERGE_LIM=4;NODE_MERGE_LIM<NODE_CUT_LIM;NODE_MERGE_LIM+=2) 
  {
    svec3_t *tabRetXY_;
    int *tabRetId_,nbrRetPt_;
    shadows_ret_t *tabRetPoly_;
    int nbrRet;

    dShad=0;
    
    printf("CUT=%d, MERGE=%d\n",NODE_CUT_LIM,NODE_MERGE_LIM);
    totime=otime=clock();
#define RM 1000000

    for(r=0;r<RM;r++) {
      if(a>(2*M_PI))a=0;
      if(a2>(2*M_PI))a2=0;
      if(a3>(2*M_PI))a3=0;

      for(i=0;i<16;i++)
	mat[i%4][i/4]= D*(i%4==i/4);
      mat[3][3]=1.;
      //for(i=0;i<16;i++)
      //  mati[i%4][i/4]= 1./D*(i%4==i/4);
      //mati[3][3]=1.;
      
    // calcul matrice 
    
    for(i=0;i<16;i++)
      mat2[i%4][i/4]= i%4==i/4;
    mat2[0][0]=cos(a);
    mat2[0][1]=sin(a);
    mat2[1][0]=-sin(a);
    mat2[1][1]=cos(a);
    MUL_MAT(mat,mat2);
    
    for(i=0;i<16;i++)
      mat2[i%4][i/4]= i%4==i/4;
    mat2[0][0]=cos(a2);
    mat2[0][2]=-sin(a2);
    mat2[2][0]=sin(a2);
    mat2[2][2]=cos(a2);
    MUL_MAT(mat,mat2);
    
    for(i=0;i<16;i++)
      mat2[i%4][i/4]= i%4==i/4;
    mat2[1][1]=cos(a3);
    mat2[1][2]=sin(a3);
    mat2[2][1]=-sin(a3);
    mat2[2][2]=cos(a3);
    MUL_MAT(mat,mat2);
    
    for(i=0;i<16;i++)
      mat2[i%4][i/4]= i%4==i/4;
    mat2[2][3]=D;
    MUL_MAT(mat,mat2);
    //mat[2][3]+=1;
    
    /*
      for(i=0;i<16;i++)
      mat[i%4][i/4]=mat2[i%4][i/4]= i%4==i/4;
    mat[0][0]=mat[1][1]=mat[2][2]=6./md;
    mat[0][3]=-6./md*tmin[0];
    mat[1][3]=-6./md*tmin[1];
    mat[2][3]=-6./md*tmin[2];
      
    mat2[0][0]=sin(a);
    mat2[0][1]=cos(a);
    mat2[1][0]=-cos(a);
    mat2[1][1]=sin(a);
    MUL_MAT(mat,mat2);

    for(i=0;i<16;i++)
      mat2[i%4][i/4]= i%4==i/4;
    mat2[0][0]=sin(a2);
    mat2[0][2]=-cos(a2);
    mat2[2][0]=cos(a2);
    mat2[2][2]=sin(a2);
    MUL_MAT(mat,mat2);

    for(i=0;i<16;i++)
      mat2[i%4][i/4]= i%4==i/4;
    mat2[1][1]=sin(a3);
    mat2[1][2]=cos(a3);
    mat2[2][1]=-cos(a3);
    mat2[2][2]=sin(a3);
    MUL_MAT(mat,mat2);
    
    mat[2][3]+=5;
    */
    
    tr_rot(obj.numVertex,obj.vertex,v3,mat);
    {
      int j;
      float f;
      for(i=0;i<obj.numFaces;i++) {
	poly_z[i].n=i;
	f=0;
	for(j=0;j<3;j++) {
	  f+=v3[obj.face[i][j]][2];
	}
	poly_z[i].z=f/3;
      }
    }
    qsort((void*)poly_z,obj.numFaces,sizeof(poly_z_t),comp_poly_z);
    tr_proj(obj.numVertex,v3,v2,mat);
#define RB 0
#define IB 5
    //printf("r=%d\n",r);
    //dShad=1;
    for(i=0;i<obj.numFaces;i++)
      {
	//r2++;
	//for(j=0;j<3;j++)
	//  printf("%f %f (%d);",v2[obj.face[i][j]][0],v2[obj.face[i][j]][1],obj.face[i][j]);
	//printf("(%d)\n",i);
	//dShad=1;
	//if(i==251) dShad=1;
	lalala=1;
	if(r==RB) RCH=1;
	if(r==RB && i==IB) dShad=1;
	if(dShad)
	  printf("r= %d i= %d\n",r,i);
#ifdef SHADOWS_RET_3D
	nbrRet=shadows_addPoly(shad,v3,obj.face[poly_z[i].n],3,0,&tabRetXY_,&tabRetId_,&tabRetPoly_,&nbrRetPt_);
	//shadows_addPoly(shad,v3,obj.face[i],3,0,0);
#else
	shadows_addPoly(shad,v2,obj.face[i],3,0);
#endif
#ifndef BENCH
	if(dShad)
	  //if(i%100==0) 
	  {
	    aff(shad);Evenement();
	  }
	if(dShad==2) dShad=0;
#endif
	//shadows_erase(shad,NOZONE);
	//if(r2%100==0)
	//  {aff(shad);Evenement();}
      }
    
#ifndef BENCH

    aff(shad);
    if(dShad)
      {
      Evenement();
    }
    //aff(shad);Evenement();
#endif
    //usleep(1500);
    shadows_erase(shad,NOZONE,0);
    a+=0.012;a2+=0.009126;a3+=0.018371;
    if(r && r%100==0) { 
      long long int t;
      printf("r=%d frame rate=%f poly rate=%f \n",r,100.*CLOCKS_PER_SEC/((t=clock())-otime),obj.numFaces*100.*CLOCKS_PER_SEC/((t=clock())-otime));
      //RCH=0;
      otime=t;
    }
  }
  printf("TOTAL frame rate=%f poly rate=%f \n",(double)RM*CLOCKS_PER_SEC/((clock())-totime),obj.numFaces*(double)RM*CLOCKS_PER_SEC/((clock())-totime));
  }
  
  printf("Destruction\n");
  shadows_destroy(shad);
  printf("Ok\n");

#ifndef BENCH
  DeconnectionServeur();
#endif

  return 0;
}

