/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#define GL
//#define X11
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#ifdef X11
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#endif
#ifdef GL
#include <GL/glut.h>
#endif

#include <time.h>
#include "shadows.h"
#include "utils.h"
#include "ase.h"
#include "tr.h"

#define minx -1.0
#define miny -1.0
#define maxx 1.0
#define maxy 1.0
int sizex,sizey;
#define H 1024
int STAT[5]={0,0,0,0,0};
#define D 1

typedef float v_2[2];
//typedef float v_3[3];
typedef struct {
  int n;
  float z;
} poly_z_t;


shadows_t* shad;

float a,a2,a3;
long long int otime;
aseobj obj;
v_2 *v2;
v_3 *v3,*norm,*norm_v;
int *norm_nbr;
poly_z_t *poly_z;
float tmin[3],tmax[3],md;
int r;
int noaffzone=64;
int Ra=0,Rv=0;

//extern int toto;
extern int tototo;

extern int RCH;
extern int dShad;
extern int stat_rec[2];

void XX(shadows_t *s)
{}

/******************* X 11 **************************/

#ifdef X11

Display *Serveur;
int Ecran;
Window Racine;
Window Win; 
GC gc;//,gc2,gcb;
XSizeHints x_sh;
Font font;

int ConnectionServeur(void)
{
  if((Serveur=XOpenDisplay(NULL))==NULL)
    {
      printf("Impossible de se connecter au serveur %s\n",XDisplayName(NULL));
      return(0);
    }
  Ecran=DefaultScreen(Serveur);
  Racine=RootWindow(Serveur,Ecran);
  return(1);
}

void DeconnectionServeur(void)
{
  if(font!=BadMatch)
    XUnloadFont(Serveur,font);
  XCloseDisplay(Serveur);
}

void CreeWin(void)
{
  char *name="Shadow Test";
  XGCValues xgcv;
  
  x_sh.min_width=x_sh.max_width=x_sh.base_width=sizex;
  x_sh.min_height=x_sh.max_height=x_sh.base_height=sizey;
  x_sh.flags=PMinSize|PMaxSize|PBaseSize;
  Win=XCreateSimpleWindow(Serveur,Racine,0,0,x_sh.base_width,x_sh.base_height,2,BlackPixel(Serveur,Ecran),WhitePixel(Serveur,Ecran));
  XSelectInput(Serveur,Win,ExposureMask|ButtonPressMask); 
  XStoreName(Serveur,Win,name);
  XSetStandardProperties(Serveur,Win,name,"shadow",None,NULL,0,&x_sh);
  gc=DefaultGC(Serveur,Ecran);
  XSetForeground(Serveur,gc,BlackPixel(Serveur,Ecran));

  /*FIX*/
  
  /*
    gc2=XCreateGC(Serveur,Win,0,&xgcv);
    XSetForeground(Serveur,gc,BlackPixel(Serveur,Ecran));
    //xgcv.fill_style=FillSolid;
    //xgcv.background=BlackPixel(Serveur,Ecran);
    //XSetFillStyle(Serveur,gc2,FillSolid);
    XChangeGC(Serveur,gc2,GCForeground,&xgcv);
  */
  /*
    gcb=XCreateGC(Serveur,Win,0,&xgcv);
    xgcv.line_style=LineOnOffDash;
    XChangeGC(Serveur,gcb,GCLineStyle,&xgcv);
  */

  if((font=XLoadFont(Serveur,"fixed"))==BadName)
    printf("Erreur Lors du chargement de la police \"fixed\"\n");
  else
    XSetFont(Serveur,gc,font);
  
  XMapWindow(Serveur,Win);
}

void aff(void)
{
  int x,y,o=0;
  XClearWindow(Serveur,Win);
  for(y=0;y<shad->y;y++) {
    for(x=0;x<shad->x;x++) {
      if(shad->tab[y*shad->x+x]) o++; //&(0x01<<shad->k)) o++;
      else
	{
	  if (o) {
	    XDrawLine(Serveur,Win,gc,x-o,y,x-1,y);
	    o=0;
	  }
	}
    }
    if (o) {
      XDrawLine(Serveur,Win,gc,x-o,y,x-1,y);
      o=0;
    }
  }
  XFlush(Serveur);
}

void Evenement(void)
{
  XEvent E;
  int fin=0;

  while(!fin)
    {
      //switch(XCheckMaskEvent(Serveur,ExposureMask,&E))
      XNextEvent(Serveur,&E);
      //printf("Event %d\n",E.type);
      switch(E.type)
	{
	case Expose:
	case GraphicsExpose:
	  aff();
	  break;
	case ButtonPress: fin=1;
	  break;
	}
    }
}
#endif

/******************* OPENGL **********************/
#ifdef GL

static GLfloat view_rotx = 180.0, view_roty = 0.0, view_rotz = 0.0;

/*static void
draw(void)
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();

  glRotatef(view_rotx, 1.0, 0.0, 0.0);
  glRotatef(view_roty, 0.0, 1.0, 0.0);
  glRotatef(view_rotz, 0.0, 0.0, 1.0);

  glPushMatrix();
  glTranslatef(-3.0, -2.0, 0.0);
  //glRotatef(angle, 0.0, 0.0, 1.0);
  //glCallList(gear1);
  
  glPopMatrix();

  glPopMatrix();

  glutSwapBuffers();

  /*
  Frames++;
  {
     GLint t = glutGet(GLUT_ELAPSED_TIME);
     if (t - T0 >= 5000) {
        GLfloat seconds = (t - T0) / 1000.0;
        GLfloat fps = Frames / seconds;
        printf("%d frames in %g seconds = %g FPS\n", Frames, seconds, fps);
        T0 = t;
        Frames = 0;
     }
  }
  
}
*/
static void
idle(void)
{
  if(Ra)
    {a+=0.012;a2+=0.009126;a3+=0.018371;}
  if(Rv)
    {view_rotx+=1.2;view_roty+=0.756;view_rotz+=0.9875;}
  if(a>=(2*M_PI))a=0;
  if(a2>=(2*M_PI))a2=0;
  if(a3>=(2*M_PI))a3=0;
  if(view_rotx>=360.) view_rotx-=360.;
  if(view_roty>=360.) view_roty-=360.;
  if(view_rotz>=360.) view_rotz -=360.;
  glutPostRedisplay();
}

static void
special(int k, int x, int y)
{
  switch (k) {
  case GLUT_KEY_UP:
    view_rotx+=1.2;view_roty+=0.756;view_rotz+=0.9875;
    //view_rotx += 5.0;
    break;
  case GLUT_KEY_DOWN:
    view_rotx-=1.2;view_roty-=0.756;view_rotz-=0.9875;
    //view_rotx -= 5.0;
    break;
  case GLUT_KEY_LEFT:
    a-=0.012;a2-=0.009126;a3-=0.018371;
    //view_roty += 5.0;
    break;
  case GLUT_KEY_RIGHT:
    a+=0.012;a2+=0.009126;a3+=0.018371;
    //view_roty -= 5.0;
    break;
  default:
    return;
  }
  glutPostRedisplay();
}

static void
key(unsigned char k, int x, int y)
{
  switch(k) {
  case '0': 
    noaffzone=0;
    break;
  case '1': 
    noaffzone=64;
    break;
  case '9': 
    noaffzone=128;
    break;
  case 't': 
    //toto=1-toto;
    break;
  case 'a': 
    Ra=1-Ra;
    break;
  case 'z': 
    Rv=1-Rv;
    break;
  case 'y': 
    tototo=(1+tototo)%3;
    break;
  }
  //glutPostRedisplay();
} 

/* new window size or exposure */
static void
reshape(int width, int height)
{
  GLfloat h = (GLfloat) height / (GLfloat) width;

  glViewport(0, 0, (GLint) width, (GLint) height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0, 1.0, -h, h, 5.0, 60.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -40.0);
}

void 
visible(int vis)
{
  if (vis == GLUT_VISIBLE)
    glutIdleFunc(idle);
  else
    glutIdleFunc(NULL);
}

#endif


/**************************************/


void MUL_MAT(float mat[4][4],float mat2[4][4]) {
  int i,j,k;
  float mat3[4][4];
  for(i=0;i<4;i++)
    for(j=0;j<4;j++){
      mat3[i][j]=0.;
      for(k=0;k<4;k++)
	mat3[i][j]+=mat2[i][k]*mat[k][j];
    }
  for(i=0;i<4;i++)
    for(j=0;j<4;j++)
      mat[i][j]=mat3[i][j];
}

int comp_poly_z(const void *e1,const void *e2)
{
  if (((const poly_z_t*)e1)->z > ((const poly_z_t*)e2)->z) return 1;
  else if (((const poly_z_t*)e1)->z == ((const poly_z_t*)e2)->z) return 0;
  else return -1;
}

void maininit(char *asefilename)
{
  int i,j,k;
  ase_load(asefilename,&obj);
  printf("%d %d\n",obj.numVertex,obj.numFaces);
  v2=(v_2*)malloc(obj.numVertex*sizeof(v_2));
  v3=(v_3*)malloc(obj.numVertex*sizeof(v_3));
  poly_z=(poly_z_t*)malloc(obj.numFaces*sizeof(poly_z_t));
  norm=(v_3*)malloc(obj.numFaces*sizeof(v_3));
  norm_v=(v_3*)malloc(obj.numVertex*sizeof(v_3));
  norm_nbr=(int*)malloc(obj.numVertex*sizeof(int));
  tmin[0]=tmax[0]=obj.vertex[0][0];
  tmin[1]=tmax[1]=obj.vertex[0][1];
  tmin[2]=tmax[2]=obj.vertex[0][2];
  for(i=1;i<obj.numVertex;i++) {
    for(j=0;j<3;j++) {
      tmin[j]=min(tmin[j],obj.vertex[i][j]);
      tmax[j]=max(tmax[j],obj.vertex[i][j]);
    }
  }
  for(j=0;j<3;j++) {
    float t;
    t=tmax[j];
    tmax[j]-=tmin[j];
    tmin[j]=(tmin[j]+t)/2.;
  }  
  md=max(max(tmax[0],tmax[1]),tmax[2]);
  
  for(i=0;i<obj.numVertex;i++) 
    for(j=0;j<3;j++) {
      obj.vertex[i][j]-=tmin[j];
      obj.vertex[i][j]*=1./md;
    }
  
  for(i=0;i<obj.numFaces;i++) {
    v_3 v[3],n;
    float l;
    
    for(j=0;j<3;j++) {
      v[0][j]=obj.vertex[obj.face[i][0]][j];
      v[1][j]=obj.vertex[obj.face[i][1]][j];
      v[2][j]=obj.vertex[obj.face[i][2]][j];
    }
    for(j=0;j<3;j++)
      v[0][j]-=v[2][j];
    for(j=0;j<3;j++)
      v[1][j]-=v[2][j];
    n[2]=v[0][0]*v[1][1]-v[1][0]*v[0][1];
    n[1]=v[0][2]*v[1][0]-v[1][2]*v[0][0];
    n[0]=v[0][1]*v[1][2]-v[1][1]*v[0][2];
    l=sqrt(n[0]*n[0]+n[1]*n[1]+n[2]*n[2]);
    if(l!=0.)
      for(j=0;j<3;j++)
	n[j]/=l;
    for(j=0;j<3;j++)
      norm[i][j]=n[j];
    //glNormal3fv(n);
  }
  
  for(i=0;i<obj.numVertex;i++) {
    for(j=0;j<3;j++)
      norm_v[i][j]=0.;
    norm_nbr[i]=0;
  }
  
  for(i=0;i<obj.numFaces;i++)
    for(j=0;j<3;j++) {
      norm_nbr[obj.face[i][j]]++;
      for(k=0;k<3;k++)
	norm_v[obj.face[i][j]][k]+=norm[i][k];
    }
  
  for(i=0;i<obj.numVertex;i++) {
    v_3 n;
    float l;

    //if(norm_nbr[i])
    for(j=0;j<3;j++)
      n[j]=norm_v[i][j];///norm_nbr[i];
    l=sqrt(n[0]*n[0]+n[1]*n[1]+n[2]*n[2]);
    for(j=0;j<3;j++)
      norm_v[i][j]=n[j]/l;
  }
  
  printf("Creation\n");
  shad=shadows_create(NOZONE,0);

  a=0.07;a2=0.05;a3=0.03;
  otime=clock();
  r=0;
}
  
void draw(void)
{
  int i,j;
  float mat[4][4],mat2[4][4],mati[4][4];

  int ii,jj,kk;
  svec3_t *tabRetXY_;
  int *tabRetId_,nbrRetPt_;
  shadows_ret_t *tabRetPoly_;
  int nbrRet;
  
  r++;

  //printf("%f %f %f\n",a,a2,a3);

#ifdef GL
  
  glClearColor(0.2,0.2,0.4,0.);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glPolygonMode(GL_FRONT,GL_FILL);
  glPolygonMode(GL_BACK,GL_FILL);
  glDisable(GL_CULL_FACE);
  
  glPushMatrix();
  
  //glLoadIdentity();
  
  glRotatef(view_rotx, 1.0, 0.0, 0.0);
  glRotatef(view_roty, 0.0, 1.0, 0.0);
  glRotatef(view_rotz, 0.0, 0.0, 1.0);
  //glRotatef(a2/M_PI*180., 1.0, 0.0, 0.0);
  //glRotatef(a/M_PI*180., 0.0, 1.0, 0.0);
  //glRotatef(a3/M_PI*180., 0.0, 0.0, 1.0);

  //glRotatef(vrx,1.0,0.0,0.0);
  //glRotatef(vry,0.0,1.0,0.0);
  
  //glPushMatrix();
  //glTranslatef(-6./md*tmin[0], -6./md*tmin[1], -6./md*tmin[2]-10.0);
  //glTranslatef(-tmin[0], -tmin[1], -tmin[2]-5.0);
  glTranslatef(0.,0.,0.); //40.); //-10.);
  glScalef(10.,10.,10.);
  
  
  //glRotatef(angle, 0.0, 0.0, 1.0);
  //glCallList(gear1);
  
  //glPopMatrix();
  
  //glShadeModel(GL_FLAT);
  glShadeModel(GL_SMOOTH);
  
  
#endif
      

  for(i=0;i<16;i++)
    mat[i%4][i/4]= D*(i%4==i/4);
  mat[3][3]=1.;
  for(i=0;i<16;i++)
    mati[i%4][i/4]= 1./D*(i%4==i/4);
  mati[3][3]=1.;
  
  // calcul matrice 
  
  for(i=0;i<16;i++)
    mat2[i%4][i/4]= i%4==i/4;
  mat2[0][0]=cos(a);
  mat2[0][1]=sin(a);
  mat2[1][0]=-sin(a);
  mat2[1][1]=cos(a);
  MUL_MAT(mat,mat2);
  
  for(i=0;i<16;i++)
    mat2[i%4][i/4]= i%4==i/4;
  mat2[0][0]=cos(a2);
  mat2[0][2]=-sin(a2);
  mat2[2][0]=sin(a2);
  mat2[2][2]=cos(a2);
  MUL_MAT(mat,mat2);
  
  for(i=0;i<16;i++)
    mat2[i%4][i/4]= i%4==i/4;
  mat2[1][1]=cos(a3);
  mat2[1][2]=sin(a3);
  mat2[2][1]=-sin(a3);
  mat2[2][2]=cos(a3);
  MUL_MAT(mat,mat2);
  
  for(i=0;i<16;i++)
    mat2[i%4][i/4]= i%4==i/4;
  mat2[2][3]=D;
  MUL_MAT(mat,mat2);
  //mat[2][3]+=1;

  // calcul inverse matrice
  
  for(i=0;i<16;i++)
    mat2[i%4][i/4]= i%4==i/4;
  mat2[2][3]=-D;
  MUL_MAT(mati,mat2);
  
  for(i=0;i<16;i++)
    mat2[i%4][i/4]= i%4==i/4;
  mat2[1][1]=cos(-a3);
  mat2[1][2]=sin(-a3);
  mat2[2][1]=-sin(-a3);
  mat2[2][2]=cos(-a3);
  MUL_MAT(mati,mat2);
  
  for(i=0;i<16;i++)
    mat2[i%4][i/4]= i%4==i/4;
  mat2[0][0]=cos(-a2);
  mat2[0][2]=-sin(-a2);
  mat2[2][0]=sin(-a2);
  mat2[2][2]=cos(-a2);
  MUL_MAT(mati,mat2);
  
  for(i=0;i<16;i++)
    mat2[i%4][i/4]= i%4==i/4;
  mat2[0][0]=cos(-a);
  mat2[0][1]=sin(-a);
  mat2[1][0]=-sin(-a);
  mat2[1][1]=cos(-a);
  MUL_MAT(mati,mat2);
  
  /*
  for(i=0;i<16;i++)
    mat2[i%4][i/4]=mati[i%4][i/4];
  MUL_MAT(mat2,mat);
  
  for(i=0;i<16;i++) {
    printf("%f ",mat2[i%4][i/4]);
    if(i%4==3) printf("\n");
    }*/

  tr_rot(obj.numVertex,obj.vertex,v3,mat);
  {
    int j;
    float f;
    for(i=0;i<obj.numFaces;i++) {
      poly_z[i].n=i;
      f=0;
      for(j=0;j<3;j++) {
	f+=v3[obj.face[i][j]][2];
      }
      poly_z[i].z=f/3;
    }
  }
  qsort((void*)poly_z,obj.numFaces,sizeof(poly_z_t),comp_poly_z);
  //tr_proj(obj.numVertex,v3,v2);
    
#ifdef GL
  
  {
    static GLfloat red[4] = {0.8, 0.1, 0.0, 1.0};
    //float lum=1.0;
    //lum=(float)tabRetPoly_[ii].zone/128; //*0.8+0.2;
    red[0]=0.8;
    red[1]=0.1;
    red[2]=0.;
    //red[3]=0.;
    //glColor3fv(red); //glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
    //glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, red);
  }

  //glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);
  
  {
    static GLfloat z[4]={0.,0.,0.,0.};
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT,z);
  }
  
  {
    static GLfloat pos[4] =
    {0.0, 0.0, 0.0, 0.0};
    static GLfloat la[4]={0.05,0.05,0.05,1.0};
    la[0]=la[1]=la[2]=0.15;
    pos[0]=mati[0][3];
    pos[1]=mati[1][3];
    pos[2]=mati[2][3];
    pos[3]=1.;
    
    glLightfv(GL_LIGHT0, GL_POSITION, pos);
    glLightfv(GL_LIGHT0, GL_AMBIENT, la);

    glEnable(GL_POINT_SMOOTH);
    glHint(GL_POINT_SMOOTH_HINT,GL_NICEST);
    glDisable(GL_LIGHTING);
    glPointSize(10.);
    glBegin(GL_POINTS);
    glColor3f(1.,1.,1.);
    glVertex3fv(pos);
    glEnd();
    glPointSize(1.);
    glEnable(GL_LIGHTING);

  }

  //glBegin(GL_TRIANGLES);
#endif
  //printf("---\n");
  for(i=0;i<obj.numFaces;i++) {
    if(dShad) 
      printf("r= %d i= %d\n",r,i);
    nbrRet=shadows_addPoly(shad,v3,obj.face[poly_z[i].n],3,0,&tabRetXY_,&tabRetId_,&tabRetPoly_,&nbrRetPt_);
    //printf("nbrRet=%d\n",nbrRet);
    //nbrRet=0;
    
#ifdef GL
    
    if(nbrRet)
      for(ii=0;ii<nbrRetPt_;ii++) {
	float x,y,z;
	x=tabRetXY_[ii][0];
	y=tabRetXY_[ii][1];
	z=tabRetXY_[ii][2];
	tabRetXY_[ii][0]=x*mati[0][0]+y*mati[0][1]+z*mati[0][2]+mati[0][3];
	tabRetXY_[ii][1]=x*mati[1][0]+y*mati[1][1]+z*mati[1][2]+mati[1][3];
	tabRetXY_[ii][2]=x*mati[2][0]+y*mati[2][1]+z*mati[2][2]+mati[2][3];
      }
    
    //glDisable(GL_LIGHTING);
    
    //if(RCH>0) 
    {
      
    ii=0;
    
    if(nbrRet==0 && noaffzone!=0) {
      {
	static GLfloat l[4] = {1.0, 1.0, 1.0, 1.0};
	float lum=0.;
	l[0]=lum;
	l[1]=lum;
	l[2]=lum;
	//glColor4fv(l); //glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
	//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, l);
	
	}
      
      //glBegin(GL_POINTS); //POLYGON);
      if(tototo)
	glBegin(GL_LINE_LOOP);
      else
	glBegin(GL_POLYGON);
      {
	for(jj=0;jj<3;jj++) {
	  //int k;
	  //if((k=jj)<3)
	    //  glNormal3fv(norm_v[obj.face[poly_z[i].n][k]]);
	  //else
	  glNormal3fv(norm[poly_z[i].n]);
	  glVertex3fv(obj.vertex[obj.face[poly_z[i].n][jj]]);
	}
      }
      glEnd();
    }      

    for(ii=0;ii<nbrRet;ii++) 
      {
	if(tabRetPoly_[ii].zone==noaffzone) continue;
    //printf("%d\n",tabRetPoly_[ii].nbr);
      {
	static GLfloat l[4] = {1.0, 1.0, 1.0, 1.0};
	float lum=1.0;
	lum=(float)tabRetPoly_[ii].zone/128; //*0.8+0.2;
	l[0]=1.0*lum;
	l[1]=1.0*lum;
	l[2]=1.0*lum;
	//glColor4fv(l); //glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
	//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, l);

      }
      
      //glBegin(GL_POINTS); //POLYGON);
      if(tototo)
	glBegin(GL_LINE_LOOP);
      else
#ifdef SHADOWS_TRIANGULATE
	glBegin(GL_TRIANGLES);
#else
	glBegin(GL_POLYGON);
#endif
      {
	if(dShad)
	for(jj=0;jj<tabRetPoly_[ii].nbr;jj++)
	  printf("%d ",tabRetId_[jj+tabRetPoly_[ii].start]);
	if(dShad)
	  printf("\n");
	
	for(jj=0;jj<tabRetPoly_[ii].nbr;jj++) {
	  //int k;
	  //if((k=tabRetId_[jj+tabRetPoly_[ii].start])<3)
	  //  glNormal3fv(norm_v[obj.face[poly_z[i].n][k]]);
	  //else
	  glNormal3fv(norm[poly_z[i].n]);
	  glVertex3dv(tabRetXY_[tabRetId_[jj+tabRetPoly_[ii].start]]);
	  //glVertex3fv(tabRetXY_[tabRetId_[jj+tabRetPoly_[ii].start]]);
	}
      }
      glEnd();
    }
    }
#endif
  }
  
#ifdef X11
  aff();//Evenement();
#endif
#ifdef GL
  glPopMatrix();
  glutSwapBuffers();
#endif

  shadows_erase(shad,NOZONE,0);
  if(r && r%100==0) { 
    long long int t;
    printf("r=%d rate=%f \n",r,100.*CLOCKS_PER_SEC/((t=clock())-otime));
    otime=t;
  }
  if(r==1000) {
    //printf("statrec={%d,%d}\n",stat_rec[0],stat_rec[1]);exit(0);
  }
}  


void main2(void)
{
  otime=clock();
  
  r=0;
  //for(r=0;r<401;r++) {
  while(1) {
    a+=0.012;a2+=0.009126;a3+=0.018371;
    if(a>(2*M_PI))a=0;
    if(a2>(2*M_PI))a2=0;
    if(a3>(2*M_PI))a3=0;
    draw();
  }
      
  printf("Destruction\n");
  shadows_destroy(shad);
  
}

int main(int argc,char **argv)
{
  char asefilename[100]="/root/ase/tk.ase";
  if(argc>1) {
    strcpy(asefilename,argv[1]);
    argc--;
    argv++;
  }

  maininit(asefilename);

#ifdef X11
  sizex=sizey=H;
  if(!ConnectionServeur()) exit(1);
  CreeWin();
#endif

#ifdef GL
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);
  
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(600, 600);
  glutCreateWindow("Test Shadows");
  //init(argc, argv);  
  
  /*{
    static GLfloat pos[4] =
    {0.0, 0.0, 0.0, 0.0};
    glLightfv(GL_LIGHT0, GL_POSITION, pos);
    }*/
  glEnable(GL_CULL_FACE);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);

  glEnable(GL_NORMALIZE);
  
  if (argc > 1 && strcmp(argv[1], "-info")==0) {
    printf("GL_RENDERER   = %s\n", (char *) glGetString(GL_RENDERER));
    printf("GL_VERSION    = %s\n", (char *) glGetString(GL_VERSION));
    printf("GL_VENDOR     = %s\n", (char *) glGetString(GL_VENDOR));
    printf("GL_EXTENSIONS = %s\n", (char *) glGetString(GL_EXTENSIONS));
  }

  glutDisplayFunc(draw);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(key);
  glutSpecialFunc(special);
  glutVisibilityFunc(visible);

  glutMainLoop();
#else
  main2();
#endif
  


#ifdef X11
  DeconnectionServeur();
#endif
  return 0;
}

