/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "tr.h"

void tr_rotProj(int n,float vertex[][3],float out[][2],float mat[4][4])
{
  int i;
  
  for(i=0;i<n;i++) {
    float x,y,z;
    x=vertex[i][0]*mat[0][0]+vertex[i][1]*mat[0][1]
      +vertex[i][2]*mat[0][2]+mat[0][3];
    y=vertex[i][0]*mat[1][0]+vertex[i][1]*mat[1][1]
      +vertex[i][2]*mat[1][2]+mat[1][3];
    z=vertex[i][0]*mat[2][0]+vertex[i][1]*mat[2][1]
      +vertex[i][2]*mat[2][2]+mat[2][3];
    if(z!=0.) {
      out[i][0]=x/z;
      out[i][1]=y/z;
    }
  }
}

void tr_rot(int n,float vertex[][3],float out[][3],float mat[4][4])
{
  int i;
  
  for(i=0;i<n;i++) {
    out[i][0]=vertex[i][0]*mat[0][0]+vertex[i][1]*mat[0][1]
      +vertex[i][2]*mat[0][2]+mat[0][3];
    out[i][1]=vertex[i][0]*mat[1][0]+vertex[i][1]*mat[1][1]
      +vertex[i][2]*mat[1][2]+mat[1][3];
    out[i][2]=vertex[i][0]*mat[2][0]+vertex[i][1]*mat[2][1]
      +vertex[i][2]*mat[2][2]+mat[2][3];
  }
}

void tr_proj(int n,float vertex[][3],float out[][2])
{
  int i;
  
  for(i=0;i<n;i++) {
    if(vertex[i][2]!=0.) {
      out[i][0]=vertex[i][0]/vertex[i][2];
      out[i][1]=vertex[i][1]/vertex[i][2];
    }
  }
}

      
